import time, sys, socket



class CacheInterface:

	def __init__ (self):
		self.o_Cache = Cache ()
		self.p_StartingNode = None
		self.p_CurrentNode = self.o_Cache.p_Root
		self.p_PreviousNode = None
		self.s_PreviousMessage = None
		self.s_LastLiveResponse = None
		self.lst_Messages = []
		self.b_NeedSave = False
		self.b_PassThrough = False
		self.s_RequiredEnvStartingState = ''


	def load_cache (self, _file):
		self.o_Cache.load (_file)
		self.p_CurrentNode = self.o_Cache.p_Root


	def save_cache (self, _file):
		self.o_Cache.save (_file)
		self.b_NeedSave = False


	def rewind (self, _sRequiredStartingEnvState):
		self.s_RequiredEnvStartingState = _sRequiredStartingEnvState.strip ()
		self.p_CurrentNode = self.o_Cache.p_Root.map_ActionToResponse.get (self.s_RequiredEnvStartingState, None)
		if None == self.p_CurrentNode:
			self.p_CurrentNode = CacheNode ()
			self.o_Cache.p_Root.map_ActionToResponse [self.s_RequiredEnvStartingState] = self.p_CurrentNode

		self.p_StartingNode = self.p_CurrentNode
		self.p_PreviousNode = None
		self.s_LastLiveResponse = None
		self.lst_Messages = []
		self.b_EnvironmentReset = False


	



	def soc_send_receive (self, _socClient, _sMessage, _sLog):
		file_InteractionLog.write ('            ' + _sLog + ' : ' + _sMessage.strip () + '\n')

		try:
			_socClient.send (_sMessage)
		except:
			file_InteractionLog.write ('[ERROR] exception in soc_send_receive on sending.\n')
			file_InteractionLog.write (str (sys.exc_info ()) + '\n')
			traceback.print_tb (sys.exc_info ()[2], None, file_InteractionLog)	
			raise

		try:
			sResponse = ''
			while '\x10' not in sResponse:
				sResponse = sResponse + _socClient.recv (1024)
		except:
			file_InteractionLog.write ('[WARNING] exception in soc_send_receive on receiving.\n')
			file_InteractionLog.write ('        received : "' + sResponse + '"\n')
			file_InteractionLog.write (str (sys.exc_info ()) + '\n')
			traceback.print_tb (sys.exc_info ()[2], None, file_InteractionLog)	
			return None

		return sResponse






	def send (self, _socClient, _sMessage):

		oCacheNode = self.p_CurrentNode.map_ActionToResponse.get (_sMessage.strip (), None)
		if (None != oCacheNode) and (False == self.b_PassThrough):
			file_InteractionLog.write ('            csh : ' + _sMessage.strip () + '\n')
			self.lst_Messages.append (_sMessage)
			self.p_CurrentNode = oCacheNode
			return oCacheNode.s_Response

		else:
			self.b_NeedSave = True


			try:
				# make environment current ...			
				if False == self.b_EnvironmentReset:
					reset_environment_to_snapshot (self.s_RequiredEnvStartingState)
					self.b_EnvironmentReset = True

				sMessage = _sMessage
				if len (self.lst_Messages) > 0:
					file_InteractionLog.write ('            replay on : ' + _sMessage.strip () + '\n')
					sLastLiveResponse = self.make_env_current (_socClient)
					if None == sLastLiveResponse:
						return None
					self.lst_Messages = []
					if '!' == _sMessage [0]:
						sMessage = self.convert_message_to_latest (_socClient, _sMessage, self.p_CurrentNode)
						if None == sMessage:
							return None

				# send current message to environment ...
				self.s_LastLiveResponse = self.soc_send_receive (_socClient, sMessage, 'soc')
				if None == self.s_LastLiveResponse:
					return None
				if 'restart complete' in self.s_LastLiveResponse:
					file_InteractionLog.write ('[ERROR]  "restart complete" received on interaction\n')
					return self.s_LastLiveResponse

			except:
				file_InteractionLog.write ('[ERROR] Caught exception on cache:send\n')
				file_InteractionLog.write (str (sys.exc_info ()) + '\n')
				traceback.print_tb (sys.exc_info ()[2], None, file_InteractionLog)	
				return None


			oCacheNode = self.o_Cache.get_node (_sMessage, self.s_LastLiveResponse)
			self.p_CurrentNode.map_ActionToResponse [_sMessage.strip ()] = oCacheNode
			self.p_CurrentNode = oCacheNode
			self.p_StartingNode = oCacheNode

			return oCacheNode.s_Response

	




	def make_env_current (self, _socClient):
		# clear connection of left-over bytes ...
		_socClient.settimeout (None)
		_socClient.send ('\n')
		sResponse = ' '
		try:
			while '' != sResponse:
				time.sleep (1)
				sResponse = _socClient.recv (8192, socket.MSG_DONTWAIT)
		except:
			e = sys.exc_info()[1]
			if 11 != e[0]:
				raise
		_socClient.settimeout (120)


		# replay previous messages to bring env to current expected state ...
		pCurrentNode = self.p_StartingNode
		self.p_PreviousNode = None
		self.s_PreviousMessage = None

		for iMsg, sMsg in enumerate (self.lst_Messages):

			# convert message to match object IDs in current environment ...
			sConvertedMsg = sMsg
			if '!' == sMsg [0]:
				sConvertedMsg = self.convert_message_to_latest (_socClient, sMsg, pCurrentNode)
				if None == pCurrentNode:
					return None

			# send converted message to environment ...
			self.s_LastLiveResponse = self.soc_send_receive (_socClient, sConvertedMsg, 'rpl')
			if None == self.s_LastLiveResponse:
				return None

			if 'restart complete' in self.s_LastLiveResponse:
				file_InteractionLog.write ('      [WARNING] encountered "restart complete" message while waiting for response on:\n')
				file_InteractionLog.write ('                ' + sMsg + '\n')
				print '      [WARNING] encountered "restart complete" message while waiting for response on:'
				print '                ' + sMsg


			self.s_PreviousMessage = sMsg
			self.p_PreviousNode = pCurrentNode
			pCurrentNode = pCurrentNode.map_ActionToResponse.get (sMsg.strip (), None)
			self.p_StartingNode = pCurrentNode

		return self.s_LastLiveResponse







	def convert_message_to_latest (self, _socClient, _sMessage, _pCurrentNode):
		if '!' != _sMessage [0]:
			return _sMessage;

		sConvertedMsg = None
		iAttempts = 0
		while iAttempts < 2:
			iAttempts = iAttempts + 1

			sConvertedMsg = self.convert_msg_from_cache (_sMessage, self.s_LastLiveResponse, _pCurrentNode.s_Response)
			if None != sConvertedMsg:
				break

			elif None == self.s_PreviousMessage:
				file_InteractionLog.write ('[ERROR] failed to convert message to latest object IDs for the very first command\n')
				file_InteractionLog.write ('        message : ' + _sMessage + '\n')
				return None

			elif self.s_PreviousMessage.startswith ('*'):
				print '[INFO] Will retry request. Attempt :', iAttempts, ' msg:', self.s_PreviousMessage
				file_InteractionLog.write ('[INFO] Will retry request. Attempt : ' +\
											str (iAttempts) + ' msg: ' + self.s_PreviousMessage + '\n')
				self.s_LastLiveResponse = self.soc_send_receive (_socClient, self.s_PreviousMessage, 'rty')
				if None == self.s_LastLiveResponse:
					return None
			else:
				break

		# if we weren't able to do the convertion, then trouble !
		if None == sConvertedMsg:
			if self.p_PreviousNode is not None:
				del self.p_PreviousNode.map_ActionToResponse [self.s_PreviousMessage.strip ()]
			return None

		return sConvertedMsg







	def convert_msg_from_cache (self, _sMsg, _sLastLiveResponse, _sCachedResponse):

		if '*' == _sMsg.strip ():
			return _sMsg

		iLiveObjectCount = 0
		iCachedObjectCount = 0

		# extract object id from message				
		sCachedObjectID = _sMsg[1:].split (':')[0]
		if '*' == sCachedObjectID:
			return _sMsg

		# convert cached response to object list		
		sCachedObject = None
		iCachedObjectCount = 0
		lstRawObjects = _sCachedResponse.split ('\x03')
		for sRawObject in lstRawObjects:
			sRawObject = sRawObject.strip ()
			if '' == sRawObject:
				continue
			if '\x10' in sRawObject:
				continue
			iCachedObjectCount = iCachedObjectCount + 1
			if sRawObject.split ('\x01', 1)[0] == sCachedObjectID:
				sCachedObject = sRawObject

		if None == sCachedObject:
			file_InteractionLog.write ('[ERROR] object (originally selected from cache) not found in cache on next step! (I think...)\n') 
			file_InteractionLog.write ('        message   :' + _sMsg + '\n')
			file_InteractionLog.write ('        object id :' + sCachedObjectID + '\n')
			file_InteractionLog.write ('------------------------------------------------\n')
			file_InteractionLog.write ('\n'.join (lstRawObjects) + '\n')
			file_InteractionLog.write ('------------------------------------------------\n')
			return None

		# remove ids from cached object ...				
		sCachedObjectFeatures = sCachedObject.split ('\x01', 3)[-1]

		# convert previous live response to object list
		sLiveObjectID = None

		# match object by features and possibly object id ...
		sObjectWithOriginalID = None
		iLiveObjectCount = 0
		lstRawObjects = _sLastLiveResponse.split ('\x03')
		for sRawObject in lstRawObjects:
			sRawObject = sRawObject.strip ()
			if '' == sRawObject:
				continue
			if '\x10' in sRawObject:
				continue
			iLiveObjectCount = iLiveObjectCount + 1

			(sID, sMwID, sAwID, sFeatures) = sRawObject.split ('\x01', 3)
			if sFeatures == sCachedObjectFeatures:
				if None == sLiveObjectID:
					sLiveObjectID = sID
				elif sID == sCachedObjectID:
					sLiveObjectID = sID

			if sID == sCachedObjectID:
				sObjectWithOriginalID = (sFeatures, sRawObject)
		
		# if we were unable to match the object by features only, 	
		# check for object id match ...								
		if None == sLiveObjectID:
			if None != sObjectWithOriginalID:
				lstMismatch = map (lambda (x,y): x != y, \
												 zip (sCachedObjectFeatures.split ('\x01'), \
												 	  sObjectWithOriginalID [0].split ('\01')))
				setMismatchIndex = set (map (lambda (i,x): i, filter (lambda (i,x): x, enumerate (lstMismatch))))
				setRemainder = setMismatchIndex - set ([raw_FG, raw_NEWLY_FG])
				if 0 == len (setRemainder):
					sLiveObjectID = sCachedObjectID
				else:
					print '[ERROR] feature mismatch, object id match, but feature mismatch is not innocuous'
					file_InteractionLog.write ('[ERROR] feature mismatch, object id match, but feature mismatch is not innocuous\n')
					file_InteractionLog.write ('diff               : ' + str (setMismatchIndex) + '\n')
					file_InteractionLog.write ('innocuous features : ' + str (set ([raw_FG, raw_NEWLY_FG])) + '\n')
					file_InteractionLog.write ('        ' + sCachedObject + '\n')
					file_InteractionLog.write ('        ' + sObjectWithOriginalID [1] + '\n')


		bError = False
		if iLiveObjectCount != iCachedObjectCount:
			bError = True
			print '[WARNING] object count mis-match. L: ' + str (iLiveObjectCount) + ' C:' + str(iCachedObjectCount)
			file_InteractionLog.write ('[WARNING] object count mis-match. L: ' +\
										str (iLiveObjectCount) + ' C:' + str(iCachedObjectCount) + '\n')
		
		if None == sLiveObjectID:
			bError = True
			print '[ERROR] could not find matching live object. Message: ' + _sMsg.strip ()
			file_InteractionLog.write ('[ERROR] could not find matching live object. Message: ' + _sMsg.strip () + '\n')

		if True == bError:
			file_InteractionLog.write ('cache ---------------------------------------------\n')
			file_InteractionLog.write (_sCachedResponse + '\n')
			file_InteractionLog.write ('live  ---------------------------------------------\n')
			file_InteractionLog.write (_sLastLiveResponse + '\n')
			file_InteractionLog.flush ()

		if iLiveObjectCount != iCachedObjectCount:
			return None
		if sLiveObjectID is None:
			return None

		# convert object_id to new environment ...
		sMsg = '!' + sLiveObjectID + ':' + _sMsg.split (':', 1)[1]

		return sMsg



