import traceback

n = ['o:', 'm:', 'a:', 'nc:', 'ed:', 'v:', '+v:', 's:', '+s:', 'f:', '+f:', 'g:', '+g:', 'i:', '+i:', 'c:', 'n:']

rgx_Whitespace = re.compile ('[ \t]+')
rgx_WhitespaceNoTab = re.compile ('[ ]+')

#																	
raw_OBJECT_ID				= 0
raw_MAIN_WND_ID				= 1
raw_ACT_WND_ID				= 2
raw_OBJECT_NAME				= 3
raw_OBJECT_CLASS			= 4
raw_FAMILY_TOUCHED			= 5
raw_OBJECT_TOUCHED			= 6
raw_MAIN_WND_TOUCHED		= 7
raw_ACT_WND_TOUCHED			= 8
raw_NAME_CHANGED			= 9
raw_NAME_EDIT_DIST			= 10
raw_VISIBLE					= 11
raw_NEWLY_VISIBLE			= 12
raw_SHOWING					= 13
raw_NEWLY_SHOWING			= 14
raw_INFOCUS					= 15
raw_NEWLY_INFOCUS			= 16
raw_FG						= 17
raw_NEWLY_FG				= 18
raw_INPUT_ENABLED			= 19
raw_NEWLY_INPUT_ENABLED		= 20
raw_SELECTED				= 21
raw_NEWLY_SELECTED			= 22
raw_CHILD					= 23
raw_NEW						= 24
raw_MESSAGE_LENGTH			= 25


FAMILY_ID				= 0
OBJECT_ID				= 1
MAIN_WND_ID				= 2
ACT_WND_ID				= 3
NAME_CHANGED			= 4
NAME_EDIT_DIST			= 5
VISIBLE					= 6
NEWLY_VISIBLE			= 7
SHOWING					= 8
NEWLY_SHOWING			= 9
INFOCUS					= 10
NEWLY_INFOCUS			= 11
FG						= 12
NEWLY_FG				= 13
INPUT_ENABLED			= 14
NEWLY_INPUT_ENABLED		= 15
SELECTED				= 16
NEWLY_SELECTED			= 17
CHILD					= 18
NEW						= 19
FEATURE_COUNT			= 20


#																	
def measure_state (_sObjectName, _setTouchedObjects):
	global o_CacheInterface

	# ask for state of system ...		
	sCommand = ''
	if None == _sObjectName:
		sCommand = '*'
	else:
		sCommand = '?' + _sObjectName.replace ('\x01', ' ')

	sResponse = o_CacheInterface.send (soc_Client, sCommand + '\n')
	if None == sResponse:
		return (None, None)
	sResponse = sResponse.lower ()

	# extract objects from response ...	
	lstObject = []
	bHasVisibleObjects = False
	iObjectIndex = 0

	lstRawObjects = sResponse.split ('\x03')
	for sRawObject in lstRawObjects:
		sRawObject = sRawObject.strip ()
		if '' == sRawObject:
			continue
		if '\x10' in sRawObject:
			continue

		# exception protection against message corruption during transmission ...
		if len (sRawObject.split ('\x01')) != raw_MESSAGE_LENGTH:
			continue

		fvRawObject = [None] * raw_MESSAGE_LENGTH
		for i, x in enumerate (sRawObject.split ('\x01')):
			fvRawObject [i] = x.strip ()
		if (len (fvRawObject) != raw_MESSAGE_LENGTH):
			file_InteractionLog.write ('[ERROR] in measure_state, length of received object feature vector ['\
										+ str (len (fvRawObject)) + '] is not expected value ['\
										+ str (raw_MESSAGE_LENGTH) + '\n')
			file_InteractionLog.write ('       ' + str (fvRawObject) + '\n')
		assert (len (fvRawObject) == raw_MESSAGE_LENGTH)

		oObject = Object ()
		oObject.i_Index = iObjectIndex
		oObject.s_ID = fvRawObject [raw_OBJECT_ID]
		oObject.s_MainWndID = fvRawObject [raw_MAIN_WND_ID]
		oObject.s_ActivationWndID = fvRawObject [raw_ACT_WND_ID]
		oObject.s_Name = fvRawObject [raw_OBJECT_NAME]
		oObject.s_ObjectClass = fvRawObject [raw_OBJECT_CLASS]
		oObject.i_ObjectClass = map_ObjectClassToIndex.get (oObject.s_ObjectClass, None)
		oObject.d_ReplyFeatures = [0.0] * FEATURE_COUNT
		iObjectIndex = iObjectIndex + 1

		oObject.s_CleanName = rgx_NonAlnum.sub (' ', oObject.s_Name)
		oObject.s_CleanName = rgx_Whitespace.sub (' ', oObject.s_CleanName)

		oObject.d_ReplyFeatures [FAMILY_ID]				= float (fvRawObject [raw_FAMILY_TOUCHED])
		oObject.d_ReplyFeatures [OBJECT_ID]				= float (fvRawObject [raw_OBJECT_TOUCHED])
		oObject.d_ReplyFeatures [MAIN_WND_ID]			= float (fvRawObject [raw_MAIN_WND_TOUCHED])
		oObject.d_ReplyFeatures [ACT_WND_ID]			= float (fvRawObject [raw_ACT_WND_TOUCHED])

		oObject.d_ReplyFeatures [NAME_CHANGED]			= float (fvRawObject [raw_NAME_CHANGED])
		oObject.d_ReplyFeatures [NAME_EDIT_DIST]		= 0
		oObject.d_ReplyFeatures [VISIBLE]				= float (fvRawObject [raw_VISIBLE])
		oObject.d_ReplyFeatures [SHOWING]				= float (fvRawObject [raw_SHOWING])
		oObject.d_ReplyFeatures [INFOCUS]				= float (fvRawObject [raw_INFOCUS])
		oObject.d_ReplyFeatures [FG]					= float (fvRawObject [raw_FG])
		oObject.d_ReplyFeatures [INPUT_ENABLED]			= float (fvRawObject [raw_INPUT_ENABLED])
		oObject.d_ReplyFeatures [SELECTED]				= float (fvRawObject [raw_SELECTED])
		oObject.d_ReplyFeatures [CHILD]					= float (fvRawObject [raw_CHILD])
		oObject.d_ReplyFeatures [NEW]					= float (fvRawObject [raw_NEW])

		# the following features as sent by the os interaction agent make sense for learning
		# only after atleast one action has been performed in the environment ...			
		if len (_setTouchedObjects) > 0:
			oObject.d_ReplyFeatures [NEWLY_VISIBLE]			= float (fvRawObject [raw_NEWLY_VISIBLE])
			oObject.d_ReplyFeatures [NEWLY_SHOWING]			= float (fvRawObject [raw_NEWLY_SHOWING])
			oObject.d_ReplyFeatures [NEWLY_INFOCUS]			= float (fvRawObject [raw_NEWLY_INFOCUS])
			oObject.d_ReplyFeatures [NEWLY_FG]				= float (fvRawObject [raw_NEWLY_FG])
			oObject.d_ReplyFeatures [NEWLY_INPUT_ENABLED]	= float (fvRawObject [raw_NEWLY_INPUT_ENABLED])
			oObject.d_ReplyFeatures [NEWLY_SELECTED]		= float (fvRawObject [raw_NEWLY_SELECTED])
		else:
			oObject.d_ReplyFeatures [NEWLY_VISIBLE]			= float (fvRawObject [raw_VISIBLE])
			oObject.d_ReplyFeatures [NEWLY_SHOWING]			= float (fvRawObject [raw_SHOWING])
			oObject.d_ReplyFeatures [NEWLY_INFOCUS]			= float (fvRawObject [raw_INFOCUS])
			oObject.d_ReplyFeatures [NEWLY_FG]				= float (fvRawObject [raw_FG])
			oObject.d_ReplyFeatures [NEWLY_INPUT_ENABLED]	= float (fvRawObject [raw_INPUT_ENABLED])
			oObject.d_ReplyFeatures [NEWLY_SELECTED]		= float (fvRawObject [raw_SELECTED])

		oObject.v_RawFeatures = fvRawObject
		lstObject.append (oObject)

		bHasVisibleObjects = bHasVisibleObjects or ('1' == fvRawObject [raw_VISIBLE])
	
	return (lstObject, bHasVisibleObjects)



#																	
def send_action (_oUIObject, _sAction, _sText):
	global o_CacheInterface

	sCommand = ''
	if None != _oUIObject:
		sCommand = '!' + _oUIObject.s_ID + ':' + _sAction
	else:
		sCommand = '!*:' + _sAction
	if (None != _sText) and ('' != _sText):
		sCommand = sCommand + '|' + _sText
	

	sResponse = o_CacheInterface.send (soc_Client, sCommand + '\n')
	if None == sResponse:
		return None

	if '[ERROR]' in sResponse:
		print '[WARNING] Error response received from OS agent.'
		print 'command ->' + sCommand + '<-'
		print 'response:'
		print '---------------------------------------------'
		print sResponse
		print '---------------------------------------------'

		file_InteractionLog.write ('[WARNING] Error response received from OS agent.\n')
		file_InteractionLog.write ('command ->' + sCommand + '<-\n')
		file_InteractionLog.write ('response:\n')
		file_InteractionLog.write ('---------------------------------------------\n')
		file_InteractionLog.write (sResponse + '\n')
		file_InteractionLog.write ('---------------------------------------------\n')

		sInput = raw_input ('continue? [y/n] :')
		if 'n' == sInput.strip ():
			sys.exit ()

	return ('env has changed' in sResponse)



#																	
def set_environment_snapshot ():

	soc_Client.send ('>\n')
	sResponse = ''
	while '\x10' not in sResponse:
		sResponse = sResponse + soc_Client.recv (1024)
		time.sleep (1)



#																	
def reset_environment_to_snapshot (_sRequiredStartingEnvState):

	print '   reset to ' + _sRequiredStartingEnvState
	soc_Client.settimeout (600)

	i = 0
	while i < 2:
		i = i + 1
		try:
			tic = time.time ()
			soc_VMClient.send ('<< ' + _sRequiredStartingEnvState + '\n')
			time.sleep (1)
			soc_Client.send ('\n')
			time.sleep (1)
			sResponse = ''
			while ('\x10' not in sResponse) or (('reset complete' not in sResponse) and ('restart complete' not in sResponse)):
				sResponse = sResponse + soc_Client.recv (1024)
				time.sleep (1)
			toc = time.time ()
			print '      ' + str (int (toc - tic)) + ' seconds to reset'
			break

		except socket.timeout:
			print '[WARNING] Timeout (10 minutes) on environment reset, retrying...'
			file_InteractionLog.write ('[WARNING] Timeout (5 minutes) on environment reset, retrying...\n')

		except socket.error:
			# file_InteractionLog.write ('[ERROR] Caught exception on cache:reset_environment_to_snapshot\n')
			# file_InteractionLog.write (str (sys.exc_info ()) + '\n')
			# traceback.print_tb (sys.exc_info ()[2], None, file_InteractionLog)	
			# time.sleep (60)
			break

		except:
			file_InteractionLog.write ('[ERROR] Caught exception on cache:reset_environment_to_snapshot\n')
			file_InteractionLog.write (str (sys.exc_info ()) + '\n')
			traceback.print_tb (sys.exc_info ()[2], None, file_InteractionLog)	
			break

	soc_Client.settimeout (120)



#																	
def clear_connection ():

	soc_Client.settimeout (None)
	soc_Client.send ('\n')
	time.sleep (1)
	sResponse = ' '
	try:
		while '' != sResponse:
			sResponse = soc_Client.recv (1024, socket.MSG_DONTWAIT)
	except socket.error:
		e = sys.exc_info()[1]
		soc_Client.settimeout (120)
		if 11 != e[0]:
			raise

	if len (sResponse) > 0:
		print "   " + str (len (sResponse)) + " bytes cleared from socket connection."
	else:
		print '   socket connection clear.'
	soc_Client.settimeout (120)



