


	#																		
	def load_partial_annotation (self):
		print '   loading partial annotation ...'
		file = open (get_config ('partial_annotation_file'))
		lstLines = file.readlines ()
		file.close ()

		oAnnotation = None
		oSentence = None
		for sLine in lstLines:
			if '' == sLine.replace ('-', '').strip ():
				continue

			if sLine.startswith ('    article ['):
				sID = sLine.split ()[1].replace ('[', '').replace (']', '')
				iIndex = int (sLine.split ()[-3].split ('/')[0])
				oAnnotation = Annotation (sID, iIndex, False)
				self.map_ArticleIdToPartialAnnotation [sID] = oAnnotation
				self.map_ArticleIdToRewardType [sID] = 'pa'
				oSentence = None
				continue

			if sLine.startswith ('         = '):
				continue

			if sLine.startswith ('         - ') or sLine.startswith ('         ~ '):
				sLine = sLine.strip ()
				bOptional = ('~' == sLine [0])
				sLine = sLine.replace ('- ', '').replace ('~ ', '').strip ()
				sLine = rgx_Whitespace.sub (' ', sLine)
				sLine = sLine.lower ()
				if '(' in sLine:
					(pref, rem) = sLine.split ('(', 1)
					(rem, suff) = rem.split (')', 1)
					sLine = pref.strip () + '\x05' + suff.strip ()
				oSentence.lst_Actions.append ((sLine, bOptional))
				continue

			if sLine.startswith ('      '):
				oSentence = Sentence (sLine.strip ())
				oAnnotation.lst_Sentences.append (oSentence)

				continue

		print '      ' + str (len (self.map_ArticleIdToPartialAnnotation.keys ()))




	#																
	def load_vocabulary (self):
		print '      loading vocabulary ...'
		sFileName = map_Config.get ('vocabulary_file', None)
		if None == sFileName:
			print "[ERROR] 'vocabulary_file' not specified in config."
			return False

		file = open (sFileName)
		lstVocabulary = file.readlines ()
		file.close ()
		for i, word in enumerate (lstVocabulary):
			self.map_WordToIndex [word.strip ()] = i
		self.i_VocabularySize = len (self.map_WordToIndex)
		return True



	#																
	def load_weights_from_file (self, _sConfigName):
		sFileName = map_Config.get (_sConfigName, None)
		if None == sFileName:
			print "[ERROR] '" + _sConfigName + "' not specified in config."
			return None

		if True == os.access (sFileName, os.R_OK):
			# these files can get pretty big, so we need to do some fancy reading...
			iLines = 0
			iTotalLength = 0

			file = open (sFileName)
			sLastLine = ''
			sLine = file.readline ()
			while '' != sLine:
				if '' == sLine.strip ():
					sLine = file.readline ()
					continue
				iLines = iLines + 1
				iTotalLength = iTotalLength + len (sLine)
				sLastLine = sLine
				if iLines >= 10:
					break
				sLine = file.readline ()

			if '' != file.readline ():
				# we didn't get to the end of the file while reading the first few lines.
				file.seek (- iTotalLength, 2)

				sLastLine = ''
				sLine = file.readline ()
				while '' != sLine:
					if '' == sLine.strip ():
						sLine = file.readline ()
						continue
					iLines = iLines + 1
					sLastLine = sLine
					sLine = file.readline ()

			file.close ()

			if 0 == iLines:
				print "[WARNING] '" + sFileName + "' has 0 lines."
				return None

			lstWeights = []
			for sValue in sLastLine.strip ().split (','):
				lstWeights.append (float (sValue))
			return lstWeights



	#																
	def load_weights (self):
		print '      loading weights ...'

		dWeights = self.load_weights_from_file ('command_and_object_word_weights_file')
		if None != dWeights:
			print '         loaded WC-WU weights.'
			self.d_Weights_WC_WU = dWeights
		dWeights = self.load_weights_from_file ('object_weights_file')
		if None != dWeights:
			print '         loaded U weights.'
			self.d_Weights_U = dWeights
		dWeights = self.load_weights_from_file ('command_weights_file')
		if None != dWeights:
			print '         loaded C weights.'
			self.d_Weights_C = dWeights
		dWeights = self.load_weights_from_file ('parameter_word_weights_file')
		if None != dWeights:
			print '         loaded WP weights.'
			self.d_Weights_WP = dWeights

		self.d_AverageWeights_WC_WU = 1.0 * sum (self.d_Weights_WC_WU) / len (self.d_Weights_WC_WU)
		self.d_AverageWeights_U = 1.0 * sum (self.d_Weights_U) / len (self.d_Weights_U)
		self.d_AverageWeights_C = 1.0 * sum (self.d_Weights_C) / len (self.d_Weights_C)
		self.d_AverageWeights_WP = 1.0 * sum (self.d_Weights_WP) / len (self.d_Weights_WP)

		return True



	#																
	def save_weights_to_file (self, _sConfigName, _dWeights):
		sFileName = map_Config.get (_sConfigName, None)
		if None == sFileName:
			print "[ERROR] '" + _sConfigName + "' not specified in config."
			return False

		file = open (sFileName, 'a')
		lst = []
		for x in _dWeights:
			lst.append (str (x))
		file.write (', '.join (lst) + '\n')
		file.flush ()
		file.close ()



	#																
	def save_weights (self):
		self.save_weights_to_file ('command_and_object_word_weights_file', self.d_Weights_WC_WU)
		self.save_weights_to_file ('object_weights_file', self.d_Weights_U)
		self.save_weights_to_file ('command_weights_file', self.d_Weights_C)
		self.save_weights_to_file ('parameter_word_weights_file', self.d_Weights_WP)

		return True



	#																
	def clear_weight_file (self, _sConfigName):
		sFileName = map_Config.get (_sConfigName, None)
		if None == sFileName:
			print "[ERROR] '" + _sConfigName + "' not specified in config."
			return False

		file = open (sFileName, 'w')
		file.write ('')
		file.flush ()
		file.close ()



	#																
	def clear_weight_files (self):
		self.clear_weight_file ('command_and_object_word_weights_file')
		self.clear_weight_file ('object_weights_file')
		self.clear_weight_file ('command_weights_file')
		self.clear_weight_file ('parameter_word_weights_file')

		return True


