

	#															
	def __init__ (self):
		self.map_ArticleIdToPartialAnnotation = {}
		self.map_ArticleIdToRewardType = {}

		self.b_Verbose = False
		self.b_TestMode = False

		self.d_EditDistCutoff = None
		self.d_SubStrEditDistCutoff = None

		self.i_FeatureCount_WC_WU = None
		self.i_FeatureCount_U = None
		self.i_FeatureCount_C = None
		self.i_FeatureCount_WP = None

		self.d_PositiveRewardMultiplier = None
		self.d_NegativeRewardMultiplier = None
		self.d_NegativeRewardMultiplierMin = None
		self.d_NegativeRewardMultiplierMax = None
		self.lst_PositiveReward = []
		self.lst_NegativeReward = []

		self.d_LearningRate = None
		self.d_ExplorationRate = None
		self.b_EpsilonGreedy = None
		self.d_SamplingEpsilon = None
		self.i_MaxAlternates = None

		self.i_Neighbourhood_U = None
		self.i_Neighbourhood_C = None

		self.d_Weights_WC_WU = []
		self.d_Weights_U = []
		self.d_Weights_C = []
		self.d_Weights_WP = []
		self.d_AverageWeights_WC_WU = 0
		self.d_AverageWeights_U = 0
		self.d_AverageWeights_C = 0
		self.d_AverageWeights_WP = 0

		self.d_Prob_WC_WU = []
		self.d_Prob_U = []
		self.d_Prob_C = []
		self.d_Prob_WP = []

		self.d_Features_WC_WU = []
		self.d_Features_U = []
		self.d_Features_C = []
		self.d_Features_WP = []

		self.lst_States = []
		self.lst_Probabilities = []
		self.lst_Features = []
		self.lst_Actions = []
		self.lst_Feedback = []

		self.d_Trace_WC_WU = []
		self.d_Trace_U = []
		self.d_Trace_C = []
		self.d_Trace_WP = []
		self.d_WeightUpdates_WC_WU = None
		self.d_WeightUpdates_U = None
		self.d_WeightUpdates_C = None
		self.d_WeightUpdates_WP = None

		self.lst_ObjectClasses = []
		self.lst_AllCommands = []
		self.set_TypeCommandIndices = set ()
		self.map_ActionToConsequence = {}
		self.lst_CommandNeedsObject = []
		self.lst_CommandNeedsParam = []
		self.o_NoneObject = None

		self.map_WordToIndex = {}

		self.b_UseMaxProbabilityAction = False

		# intermediate information		
		self.i_ProcessedDocuments = 0
		self.i_DocumentsPerUpdate = None

		self.lst_CurrentInstructionWords = []
		self.i_CurrentInstructionLength = None
		self.set_UnusedWordLocations = None
		self.set_PotentialObjectWords = None
		self.set_PotentiallyInteractableObjects = set ()
		self.map_WordsInEnvironment = {}
		self.map_WordToObjects = {}

		self.lst_CurrentState = []
		self.lst_CurrentStateIncludingNoneObject = []
		self.i_CurrentStateObjectCount = None

		self.set_TouchedObjects = set ()
		self.i_SelectedObjectWordLocation = None
		self.i_SelectedCommandWordLocation = None
		self.i_SelectedParameterPresence = None
		self.i_SelectedParameterWordLocation = None
		self.o_SelectedObject = None
		self.i_SelectedObjectIndex = None
		self.o_SelectedCommand = None
		self.i_SelectedCommandIndex = None

		self.lst_PreviouslyUsedWords = []
		self.lst_PreviouslyUsedObjectWords = []
		self.lst_PreviouslyUsedCommandWords = []
		self.lst_PreviouslyUsedParamWords = []



	#																
	def init_learner (self):
		global set_HeldoutArticles
		global i_TotalArticles

		print '   initializing learner ...'
		self.load_vocabulary ()

		self.b_Verbose = ('1' == get_config ('verbose'))
		if 'article_count' == get_config ('documents_per_weight_update'):
			self.i_DocumentsPerUpdate = i_TotalArticles - len (set_HeldoutArticles)
		else:
			self.i_DocumentsPerUpdate = int (get_config ('documents_per_weight_update'))
		print '      updating weights every ' + str (self.i_DocumentsPerUpdate) + ' documents'
		self.b_UseMaxProbabilityAction = ('1' == get_config ('use_max_probability_action'))

		self.d_PositiveRewardMultiplier = float (get_config ('positive_reward_multiplier'))
		self.d_NegativeRewardMultiplier = float (get_config ('negative_reward_multiplier'))
		self.d_NegativeRewardMultiplierMin = float (get_config ('negative_reward_multiplier_min'))
		self.d_NegativeRewardMultiplierMax = float (get_config ('negative_reward_multiplier_max'))
	
		self.d_LearningRate = float (get_config ('learning_rate'))
		self.d_ExplorationRate = float (get_config ('exploration_rate'))
		self.b_EpsilonGreedy = ('epsilon-greedy' == get_config ('sampling_method'))
		self.d_SamplingEpsilon = float (get_config ('sampling_epsilon'))
		self.i_MaxAlternates = int (get_config ('max_alternate_interpretations'))
		if True == self.b_EpsilonGreedy:
			print '      using epsilog-greedy sampling with epsilon = ' + str (self.d_SamplingEpsilon)
		else:
			print '      using softmax sampling with exploration rate = ' + str (self.d_ExplorationRate)

		self.i_Neighbourhood_U = int (get_config ('neighbourhood_for_object'))
		self.i_Neighbourhood_WP = int (get_config ('neighbourhood_for_parameter'))
		self.b_UseBigramFeatures = ('1' == get_config ('use_bigram_features'))

		self.d_EditDistCutoff = float (get_config ('edit_distance_cutoff'))
		self.d_SubStrEditDistCutoff = float (get_config ('substring_edit_distance_cutoff'))

		# object classes ...								
		self.lst_ObjectClasses = get_config_list ('object_classes')
		for i, sClass in enumerate (self.lst_ObjectClasses):
			map_ObjectClassToIndex [sClass] = i
		self.i_ObjectClassCount = len (self.lst_ObjectClasses)

		# commands ...										
		lstCommands = get_config_list ('action_list')
		for sCommand in lstCommands:
			(sAction, sConsequence, sHasParam, sNeedsObject) = sCommand.split (':')
			self.map_ActionToConsequence [sAction] = int (sConsequence)
			if '[[none]]' == sAction:
				self.lst_AllCommands.append (None)
			else:
				self.lst_AllCommands.append (sAction)
			self.lst_CommandNeedsParam.append ('p' == sHasParam)
			self.lst_CommandNeedsObject.append ('o' == sNeedsObject)
		self.i_CommandCount = len (self.lst_AllCommands)

		self.set_TypeCommandIndices = set ()
		for iIndex, sCommand in enumerate (self.lst_AllCommands):
			if None == sCommand:
				continue
			if 'type' in sCommand:
				self.set_TypeCommandIndices.add (iIndex)


		# object features ...								
		self.lst_ObjectFeatures = get_config_list ('object_features')
		map_FeatureToIndex = {}
		for i, feature in enumerate (self.lst_ObjectFeatures):
			map_FeatureToIndex [feature] = i
		self.lst_ObjectFeaturesOfInterest = get_config_list ('object_features_of_interest')
		self.set_ObjectFeaturesOfInterest = set ()
		self.map_FeatureIndexToMessageIndex = {}
		for i, feature in enumerate (self.lst_ObjectFeaturesOfInterest):
			iMessageIndex = map_FeatureToIndex [feature]
			self.set_ObjectFeaturesOfInterest.add (iMessageIndex)
			self.map_FeatureIndexToMessageIndex [i] = iMessageIndex

		#													
		self.o_NoneObject = Object ()
		self.o_NoneObject.s_ID = '[[none]]'
		self.o_NoneObject.i_ObjectClass = map_ObjectClassToIndex ['[[none]]']

		# +1 below is for object class name in neighbourhood
		if True == self.b_UseBigramFeatures:
			self.i_FeatureCount_WC_WU = 2 * self.i_VocabularySize +\
										2 * self.i_VocabularySize * self.i_VocabularySize +\
										42
		else:
			self.i_FeatureCount_WC_WU = self.i_VocabularySize + 42


		self.i_FeatureCount_U = len (self.set_ObjectFeaturesOfInterest) + 1
		self.i_FeatureCount_C = (self.i_ObjectClassCount + 2 * self.i_VocabularySize) \
								* self.i_CommandCount
		self.i_FeatureCount_WP = self.i_VocabularySize + 41


		self.d_Weights_WC_WU = []
		self.d_Weights_U = []
		self.d_Weights_C = []
		self.d_Weights_WP = []

		if '0' == get_config ('random_initial_weights'):
			print '      using zero initial weights'
			self.d_Weights_WC_WU = [0] * self.i_FeatureCount_WC_WU
			self.d_Weights_U = [0] * self.i_FeatureCount_U
			self.d_Weights_C = [0] * self.i_FeatureCount_C
			self.d_Weights_WP = [0] * self.i_FeatureCount_WP
		else:
			print '      using random initial weights'
			self.d_Weights_WC_WU = [0] * self.i_FeatureCount_WC_WU
			for i in xrange (self.i_FeatureCount_WC_WU):
				self.d_Weights_WC_WU.append (random.uniform (-0.1, 0.1))

			for i in xrange (self.i_FeatureCount_U):
				self.d_Weights_U.append (random.uniform (-0.1, 0.1))

			for i in xrange (self.i_FeatureCount_C):
				self.d_Weights_C.append (random.uniform (-0.1, 0.1))

			for i in xrange (self.i_FeatureCount_WP):
				self.d_Weights_WP.append (random.uniform (-0.1, 0.1))




	#																
	def init_for_new_episode (self):

		self.lst_CurrentInstructionWords = []
		self.i_CurrentInstructionLength = None

		self.lst_CurrentState = []
		self.lst_CurrentStateIncludingNoneObject = []
		self.i_CurrentStateObjectCount = None

		self.set_TouchedObjects = set ()
		self.i_SelectedObjectWordLocation = None
		self.i_SelectedCommandWordLocation = None
		self.i_SelectedParameterPresence = None
		self.i_SelectedParameterWordLocation = None
		self.o_SelectedObject = None
		self.i_SelectedObjectIndex = None
		self.o_SelectedCommand = None
		self.i_SelectedCommandIndex = None

		self.lst_PreviouslyUsedWords = []
		self.lst_PreviouslyUsedObjectWords = []
		self.lst_PreviouslyUsedCommandWords = []
		self.lst_PreviouslyUsedParamWords = []


