import sys, os, random, bisect, socket, time, math, cPickle, re, shutil, copy
import psyco
psyco.full ()

map_ObjectClassToIndex = {}


#																		
class Sentence:
	def __init__ (self, _sText):
		self.s_Text = _sText
		self.lst_Actions = []


class Annotation:
	def __init__ (self, _sID, _iIndex, _bHeldout):
		self.s_ID = _sID
		self.i_Index = _iIndex
		self.lst_Sentences = []



# --------------------------------------------------------------
class Object:
	def __init__ (self):
		self.i_Index = None
		self.s_ID = ''
		self.s_MainWndID = ''
		self.s_ActivationWndID = ''
		self.s_Name = ''
		self.s_CleanName = ''
		self.i_ObjectClass = 0
		self.s_ObjectClass = ''
		self.v_RawFeatures = []
		self.d_ReplyFeatures = []



# --------------------------------------------------------------
class Article:
	def __init__ (self):
		self.i_Index = None
		self.i_ID = None
		self.lst_Instructions = []



# --------------------------------------------------------------
class Learner:

	#															
	def prerun_check_article (self, _oArticle):
		bArticleOK = True
		for iSentence, lstWords in enumerate (_oArticle.lst_Instructions):
			self.lst_CurrentInstructionWords = list (lstWords)

			bSentenceOK = True
			for x in self.lst_CurrentInstructionWords:
				if None == self.map_WordToIndex.get (x, None):
					if True == bArticleOK:
						print '[ERROR] prerun check failed on article [' + str(_oArticle.i_ID) + ']'
					if True == bSentenceOK:
						print '   ' + str (self.lst_CurrentInstructionWords)
					print '       word [' + x + '] missing from vocabulary'
					bSentenceOK = False
					bArticleOK = False
		return bArticleOK

	

	# 															
	def sample_actions (self, _oArticle):

		iTimeStep = 0
		bEnvChanged = False
		bCommandIssued = False
		sPreviousCommand = ''

		self.lst_States = []
		self.lst_Probabilities = []
		self.lst_Features = []
		self.lst_Actions = []
		self.lst_Feedback = []

		lstSequenceLogProb = []

		for iSentence, lstWords in enumerate (_oArticle.lst_Instructions):
			self.lst_CurrentInstructionWords = list (lstWords)

			# [[none]] is added to allow selection as the object_word	
			self.lst_CurrentInstructionWords.append ('[[none]]')
			self.lst_CurrentInstructionWordIndices = []
			for x in self.lst_CurrentInstructionWords:
				self.lst_CurrentInstructionWordIndices.append (self.map_WordToIndex [x])

			self.i_CurrentInstructionLength = len (lstWords)
			self.set_UnusedWordLocations = set (range (self.i_CurrentInstructionLength))
			self.lst_PreviouslyUsedWords = []
			self.lst_PreviouslyUsedObjectWords = []
			self.lst_PreviouslyUsedCommandWords = []
			self.lst_PreviouslyUsedParamWords = []

			if True == self.b_Verbose:
				print '      ' + ' '.join (lstWords)
			file_InteractionLog.write ('      ' + ' '.join (lstWords) + '\n')

			self.lst_States.append ([])
			self.lst_Probabilities.append ([])
			self.lst_Features.append ([])
			self.lst_Actions.append ([])
			self.lst_Feedback.append ([])

			bCommError = False
			iInteractionsWithEnv = 0
			iNonTypeInteractionsWithEnv = 0

			# iterate over the words in the current sentences ...		
			while len (self.set_UnusedWordLocations) > 0:

				# get environment state ...				
				if True == bCommandIssued:
					if False == self.get_environment_state ():
						bCommError = True
						break
				self.map_WordToObjects = {}
				bCommandIssued = False

				self.set_PotentialObjectWords = []
				for l in self.set_UnusedWordLocations:
					if True == self.current_env_has_word (self.lst_CurrentInstructionWords [l]):
						self.set_PotentialObjectWords.append (l)


				# compute p(a|.) & sample...			
				if False == self.compute_prob_and_sample_action (_oArticle, iSentence):
					self.lst_Probabilities [-1].append ((self.d_Prob_WC_WU, \
														 self.d_Prob_WP, \
														 self.d_Prob_C, \
														 self.d_Prob_U))
					break

				lstSequenceLogProb.append (self.compute_action_log_probability ())
				self.print_selections ()

				sAction = self.o_SelectedCommand
				if None != self.o_SelectedObject:
					sAction += ' (' + self.o_SelectedObject.s_ID +\
								') [' + self.o_SelectedObject.s_ObjectClass +\
								'] ' + self.o_SelectedObject.s_Name
				if None != self.i_SelectedParameterWordLocation:
					sAction += '  "' + self.lst_CurrentInstructionWords [self.i_SelectedParameterWordLocation] + '"'


				self.lst_States [-1].append ((self.lst_CurrentState, self.map_WordsInEnvironment, self.map_WordToObjects))
				self.lst_Probabilities [-1].append ((self.d_Prob_WC_WU, \
													 self.d_Prob_WP, \
													 self.d_Prob_C, \
													 self.d_Prob_U))
				self.lst_Features [-1].append ((self.d_Features_WC_WU, \
												self.d_Features_WP, \
												self.d_Features_C, \
												self.d_Features_U))
				self.lst_Feedback [-1].append (' ')
				self.lst_Actions [-1].append ((self.i_SelectedCommandWordLocation, \
												self.i_SelectedObjectWordLocation, \
												self.i_SelectedParameterWordLocation, \
												self.i_SelectedCommandIndex, \
												self.i_SelectedObjectIndex, \
												sAction))


				# update traces & reward ...				
				self.update_traces (iTimeStep)
				iTimeStep = iTimeStep + 1


				# send perform action in environment ...
				bEnvChanged = False
				if (None != self.o_SelectedCommand):

					iInteractionsWithEnv = iInteractionsWithEnv + 1
					if 'type' not in self.o_SelectedCommand:
						iNonTypeInteractionsWithEnv = iNonTypeInteractionsWithEnv + 1

					self.print_action ()


					# repeating the same command multiple times in consequent steps is not productive !
					sThisCommand = self.o_SelectedCommand + '\x20' +\
								   self.o_SelectedObject.s_ID + '\x20' +\
								   self.o_SelectedObject.s_Name
					if None != self.i_SelectedParameterWordLocation:
						sThisCommand = sThisCommand + '\x20' +\
										self.lst_CurrentInstructionWords [self.i_SelectedParameterWordLocation]

					#if sThisCommand == sPreviousCommand:
					#	self.lst_Feedback [-1][-1] = 'repetition'
					#	return lstSequenceLogProb

					sPreviousCommand = sThisCommand

					if ('double click' == self.o_SelectedCommand) and \
						('checkbox' == self.o_SelectedObject.s_ObjectClass):
						self.lst_Feedback [-1][-1] = 'no env change'

					# Apply the selected command to the environment ...
					self.set_TouchedObjects.add (self.o_SelectedObject.s_ID)
					self.set_TouchedObjects.add (self.o_SelectedObject.s_MainWndID)
					self.set_TouchedObjects.add (self.o_SelectedObject.s_ActivationWndID)

					if None != self.i_SelectedParameterWordLocation:
						bEnvChanged = send_action (self.o_SelectedObject, self.o_SelectedCommand, \
													self.lst_CurrentInstructionWords [self.i_SelectedParameterWordLocation])
					else:
						bEnvChanged = send_action (self.o_SelectedObject, self.o_SelectedCommand, '')

					bCommandIssued = True


					# possible unrecovereable comm protocol error.						
					# skip out of current document without changing previous rewards ...
					if None == bEnvChanged:
						bCommError = True
						break


				#										
				self.update_used_words_collections ()


			if True == bCommError:
				# we get here only if there was some potentially unrecovereable comm protocol error.
				# so don't do anything ...															
				if len (self.lst_Feedback [-1]) > 0:
					self.lst_Feedback [-1][-1] = 'comm'
				print '      comm protocol error? skipping out of document.'
				file_InteractionLog.write ('      comm protocol error? skipping out of document.\n')
				return None


			if iInteractionsWithEnv == 0:
				if len (self.lst_Feedback [-1]) > 0:
					self.lst_Feedback [-1][-1] = 'no interaction'
				elif (len (self.lst_Feedback) > 1) and (len (self.lst_Feedback [-2]) > 0):
					self.lst_Feedback [-2][-1] = 'no interaction'

				return lstSequenceLogProb


			if iNonTypeInteractionsWithEnv > 0:
				self.lst_Feedback [-1][-1] = '+'

		return lstSequenceLogProb



	# 															
	def walk_trace (self, _oArticle, _lstActions):

		iTimeStep = 0
		lstSequenceLogProb = []

		self.lst_Actions = list (_lstActions)

		for iSentence, (lstWords, lstSentenceActions, lstSentenceStates, lstSentenceProbs, lstSentenceFeatures) \
				in enumerate (zip (_oArticle.lst_Instructions, _lstActions, self.lst_States, self.lst_Probabilities, self.lst_Features)):

			self.lst_CurrentInstructionWords = list (lstWords)

			# [[none]] is added to allow selection as the object_word	
			self.lst_CurrentInstructionWords.append ('[[none]]')
			self.lst_CurrentInstructionWordIndices = []
			for x in self.lst_CurrentInstructionWords:
				self.lst_CurrentInstructionWordIndices.append (self.map_WordToIndex [x])

			self.i_CurrentInstructionLength = len (lstWords)
			self.set_UnusedWordLocations = set (range (self.i_CurrentInstructionLength))
			self.lst_PreviouslyUsedWords = []
			self.lst_PreviouslyUsedObjectWords = []
			self.lst_PreviouslyUsedCommandWords = []
			self.lst_PreviouslyUsedParamWords = []


			# iterate over the alternate actions ...					
			for oAction, (oState, mapWordsInEnv, mapWordToObjects), lstProbs, lstFeatures \
					in zip (lstSentenceActions, lstSentenceStates, lstSentenceProbs, lstSentenceFeatures):

				self.set_environment_state (oState)
				self.map_WordsInEnvironment = mapWordsInEnv
				self.map_WordToObjects = mapWordToObjects
				(lwc, lwu, lwp, c, ui, a) = oAction
				(dProb_WC_WU, dProb_WP, dProb_C, dProb_U) = lstProbs
				(dFeatures_WC_WU, dFeatures_WP, dFeatures_C, dFeatures_U) = lstFeatures

				self.set_PotentialObjectWords = []
				for l in self.set_UnusedWordLocations:
					if True == self.current_env_has_word (self.lst_CurrentInstructionWords [l]):
						self.set_PotentialObjectWords.append (l)


				# compute p(a|.) & sample...			
				assert (True == self.compute_p_wc_wu (_oArticle, iSentence))
				# self.compute_p_u ()
				# assert (self.d_Prob_U == dProb_U)
				self.d_Features_U = dFeatures_U
				self.d_Prob_U = dProb_U

				# self.compute_p_c ()
				u = self.lst_CurrentStateIncludingNoneObject [ui]
				self.compute_p_c_for_trace_walk (lwc, lwu, ui, u)

				self.set_selected_action (lwc, lwu, c, ui)

				if 1 == self.i_SelectedParameterPresence:
					self.compute_p_wp ()
				self.i_SelectedParameterWordLocation = lwp

				dSequenceLogProb = self.compute_action_log_probability ()
				lstSequenceLogProb.append (dSequenceLogProb)
				if dSequenceLogProb < -100000:
					return lstSequenceLogProb

				# update traces & reward ...				
				self.update_traces (iTimeStep)
				iTimeStep = iTimeStep + 1

				#										
				self.update_used_words_collections ()

		return lstSequenceLogProb




	# 													
	def compute_reward (self, _oArticle):
		sRewardType = self.map_ArticleIdToRewardType.get (_oArticle.i_ID, None)
		if None == sRewardType:
			return self.compute_environment_reward (_oArticle)
		elif 'pa' == sRewardType:
			return self.compute_partial_annotation_reward (_oArticle)
		elif 'fa' == sRewardType:
			return self.compute_full_annotation_reward (_oArticle)
		else:
			file_InteractionLog.write ('[ERROR]  unknown reward computation type (' + sRewardType +\
										') for article ' + str (_oArticle.i_ID) + '\n')
			file_InteractionLog.flush ()
			print '[ERROR]  unknown reward computation type (' + sRewardType +\
					') for article ' + str (_oArticle.i_ID)
			assert (False)



	# 													
	def compute_partial_annotation_reward (self, _oArticle):
		
		lstReward = []
		oAnnotation = self.map_ArticleIdToPartialAnnotation.get (_oArticle.i_ID, None)
		assert (None != oAnnotation)

		bHasMismatch = False


		for oAnnotSentence, lstActions in zip (oAnnotation.lst_Sentences, self.lst_Actions):
			for (sAnnot, bOptional), tplAction in zip (oAnnotSentence.lst_Actions, lstActions):
				(wc, wu, wp, c, o, sCommand) = tplAction
				if True == bHasMismatch:
					lstReward.append (0)
					continue

				sCommand = rgx_Whitespace.sub (' ', sCommand)
				sCommand = sCommand.lower ()
				if '(' in sCommand:
					(pref, rem) = sCommand.split ('(', 1)
					(rem, suff) = rem.split (')', 1)
					sCommand = pref.strip () + '\x05' + suff.strip ()

				if sAnnot == sCommand:
					lstReward.append (1)
				else:
					lstReward.append (-1)
					bHasMismatch = True

			if len (oAnnotSentence.lst_Actions) > len (lstActions):
				if len (lstReward) > 0:
					if lstReward [-1] > 0:
						lstReward [-1] = -1
				return lstReward


		if False == bHasMismatch:
			if len (lstReward) > 0:
				lstReward [-1] = 2
		else:
			if len (lstReward) > 0:
				if lstReward [-1] > 0:
					lstReward [-1] = -1

		return lstReward




	# 															
	def compute_environment_reward (self, _oArticle):
		
		bHaveNonTypingActions = False
		lstReward = []
		for lstWords, lstFeedback, lstActions \
				in zip (_oArticle.lst_Instructions, self.lst_Feedback, self.lst_Actions):

			iTotalLength = 0
			for w in lstWords:
				iTotalLength += len (w)

			iUsedLength = 0
			for (wc, wu, wp, c, o, a) in lstActions:
				iUsedLength += len (lstWords [wc])
				iUsedLength += len (lstWords [wu])
				if None != wp:
					iUsedLength += len (lstWords [wp])
				bHaveNonTypingActions |= (c not in self.set_TypeCommandIndices)


			dUsedRatio = 1.0 * iUsedLength / iTotalLength
			if dUsedRatio > 1:
				file_InteractionLog.write ('[WARNING]  sentence used ratio = ' + str (dUsedRatio) + ' > 1 !\n')

			iMaxPossibleEnvInteractions = len (lstWords)
			dInteractionRatio = 1.0 * (iMaxPossibleEnvInteractions - len (lstActions)) \
								/ iMaxPossibleEnvInteractions


			for sFeedback in lstFeedback:
				if ' ' == sFeedback:
					lstReward.append (0)
					continue
				if 'comm' == sFeedback:
					lstReward.append (0)
					continue

				if 'repetition' == sFeedback:
					lstReward.append (-1.0 * self.d_NegativeRewardMultiplier)
					continue
				if 'no env change' == sFeedback:
					lstReward.append (-1.0 * self.d_NegativeRewardMultiplier)
					continue
				if 'no interaction' == sFeedback:
					lstReward.append (-1.0 * self.d_NegativeRewardMultiplier)
					continue

				if '+' == sFeedback:
					lstReward.append (self.d_PositiveRewardMultiplier * dUsedRatio * dInteractionRatio)
			

		if (False == bHaveNonTypingActions) and \
			(0 == sum (lstReward)) and \
			(len (lstReward) > 0):
			lstReward [-1] = -1.0 * self.d_NegativeRewardMultiplier


		# compute cumulative reward ...				
		for i in xrange (len (lstReward) - 1, 0, -1):
			lstReward [i-1] += lstReward [i]

		return lstReward





	# 															
	def process_article (self, _oArticle):
		global o_CacheInterface

		# initialize environment state ...						
		o_CacheInterface.rewind (_oArticle.s_RequiredStartingEnvState)

		# initialize learner for learning episode ...	
		self.init_for_new_episode ()
		self.initialize_traces ()
		self.lst_Feedback = []

		# get environment state ...						
		if False == self.get_environment_state ():
			return

		# saple_actions returns False if an error		
		# occurs that precludes parameter update.		
		lstPrimeLogProb = self.sample_actions (_oArticle)
		if 0 == len (self.lst_Actions [-1]):
			self.lst_Actions.pop ()
		lstPrimeActionSequence = self.lst_Actions
		if None == lstPrimeLogProb:
			print '    sample_actions returned None.'
			file_InteractionLog.write ('    sample_actions returned None.\n')
			return
		if 0 == len (lstPrimeLogProb):
			print '    sample_actions returned [].'
			file_InteractionLog.write ('    sample_actions returned [].\n')
			return

		# self.print_word_sequence (_oArticle)
		for i in xrange (len (lstPrimeLogProb) - 1, 0, -1):
			lstPrimeLogProb [i-1] += lstPrimeLogProb [i]


		# compute reward based on action sequence ...	
		lstReward = self.compute_reward (_oArticle)
		if None == lstReward:
			print '    compute_reward returned None.'
			file_InteractionLog.write ('    compute_reward returned None.\n')
			return
		sReward = '      reward : ' + str (map (lambda x: '%.1f'%x, lstReward))
		print sReward
		file_InteractionLog.write (sReward + '\n')


		# trim actions beyond negative reward in the case of annotated rewards ...
		sRewardType = self.map_ArticleIdToRewardType.get (_oArticle.i_ID, None)
		if ('pa' == sRewardType) or ('fa' == sRewardType):
			iRemainder = len (lstReward)
			while iRemainder > 1:
				if 0 != lstReward [iRemainder - 1]:
					break
				iRemainder -= 1

			for j in xrange (len (self.lst_Actions)):
				lstActions = self.lst_Actions [j]
				if 0 == iRemainder:
					self.lst_Actions = self.lst_Actions [:j]
					break
				elif len (lstActions) > iRemainder:
					self.lst_Actions [j] = lstActions [:iRemainder]
					self.lst_Actions = self.lst_Actions [:j + 1]
					break
				else:
					iRemainder -= len (lstActions)


		# update weights ...
		if False == self.b_TestMode:
			tic = time.clock ()
			# compute alternate interpretations ...			
			lstAlternateInterpretations = self.compute_alternate_interpretations (_oArticle)
			if 0 == len (lstAlternateInterpretations):
				print '    compute_alternate_interpretations returned 0 options.'
				file_InteractionLog.write ('    compute_alternate_interpretations returned 0 options.\n')
				return

			print '      alternates : ' + str (len (lstAlternateInterpretations))
			file_InteractionLog.write ('      alternates : ' + str (len (lstAlternateInterpretations)) + '\n')
				
			if len (lstAlternateInterpretations) > self.i_MaxAlternates:
				random.shuffle (lstAlternateInterpretations)
				lstAlternateInterpretations = lstAlternateInterpretations [: self.i_MaxAlternates]
				if lstPrimeActionSequence not in lstAlternateInterpretations:
					lstAlternateInterpretations [-1] = lstPrimeActionSequence
				

			# compute the probability of the command sequence
			iActionSequenceLength = len (lstReward)
			lstUpdateInformation = []
			dCommandSequenceProbWeighted = 0
			for lstActions in lstAlternateInterpretations:
				# compute traces for alternate actions ...	
				self.init_for_new_episode ()
				self.initialize_traces ()
				lstAlternateLogProb = self.walk_trace (_oArticle, lstActions)
				if len (lstAlternateLogProb) < iActionSequenceLength:
					continue
				for i in xrange (len (lstAlternateLogProb) - 1, 0, -1):
					lstAlternateLogProb [i-1] += lstAlternateLogProb [i]
				if lstAlternateLogProb [0] < -10000:
					continue
				dCommandSequenceProbWeighted += math.exp (lstAlternateLogProb [0] - lstPrimeLogProb [0])

				lstReward = self.compute_reward (_oArticle)
				lstUpdateInformation.append ((lstAlternateLogProb [0], \
											  lstReward, \
											  self.d_Trace_WC_WU, \
											  self.d_Trace_C, \
											  self.d_Trace_U, \
											  self.d_Trace_WP))

			try:
				dCommandSequenceLogProb = math.log (dCommandSequenceProbWeighted) + lstPrimeLogProb [0]
			except:
				print '      command sequence prob weighted : ', dCommandSequenceProbWeighted
				file_InteractionLog.write ('      command sequence prob weighted : ' + str (dCommandSequenceProbWeighted) + '\n')
				file_InteractionLog.flush ()
				return

			print '      command sequence prob : ', dCommandSequenceLogProb
			file_InteractionLog.write ('      command sequence prob : ' + str (dCommandSequenceLogProb) + '\n')



			# compute weight updates ...					
			lstTotalReward = [0] * len (lstReward)
			for (dAlternateLogProb, lstReward, dTraceWCWU, dTraceC, dTraceU, dTraceWP) in lstUpdateInformation:
				# compute traces for alternate actions ...	
				self.initialize_traces ()
				self.d_Trace_WC_WU = dTraceWCWU
				self.d_Trace_C = dTraceC
				self.d_Trace_U = dTraceU
				self.d_Trace_WP = dTraceWP

				# compute reward based on action sequence ...	
				dWeight = math.exp (dAlternateLogProb - dCommandSequenceLogProb)
				lstReward = map (lambda r: 1.0 * r * dWeight, lstReward)

				# compute & perform parameter updates ...	
				if None != lstReward:
					lstTotalReward = map (lambda (x,y): x+y, zip (lstReward, lstTotalReward))
					self.compute_weight_update (lstReward)

			sReward = '      total reward : ' + str (map (lambda x: '%.1f'%x, lstTotalReward))
			print sReward
			file_InteractionLog.write (sReward + '\n')

			toc = time.clock ()
			sMsg = '      alternates : ' + str (len (lstAlternateInterpretations)) + \
				   '   time : ' + str (toc - tic) + ' seconds'
			print sMsg
			file_InteractionLog.write (sMsg + '\n')


		# we do block updates of the weights, so first have to check	
		# if a sufficient number of actions have been sampled...		
		# self.i_ProcessedDocuments += 1
		# if self.i_ProcessedDocuments > self.i_DocumentsPerUpdate:
		self.update_weights ()
		self.save_weights ()
		self.i_ProcessedDocuments = 0




	# 															
	def compute_word_selection_range (self, _lstWords, _lstActions, _wc, _wu, _wp):
		lstUsedWords = filter (lambda x: None != x, [_wc, _wu, _wp])
		iFirstWord = min (lstUsedWords)
		iLastWord = max (lstUsedWords)

		lstPreceeding = [-1]
		lstFollowing = [len (_lstWords)]
		for wc, wu, wp, c, u, a in _lstActions:
			if wc < iFirstWord:
				lstPreceeding.extend ([wc, wu])
				if None != wp:
					lstPreceeding.append (wp)
			elif wc > iLastWord:
				lstFollowing.extend ([wc, wu])
				if None != wp:
					lstFollowing.append (wp)

		iPreceeding = max (lstPreceeding)
		iFollowing = min (lstFollowing)

		setPotentialWords = set (range (iPreceeding + 1, iFollowing))

		return (setPotentialWords, iFirstWord, iLastWord)



	# 															
	def compute_alternate_word_selection (self, _lstWords, _lstActions, \
										  _lstProbs, _lstNextProbs, \
										  _wc, _wu, _wp, _c, _u, _a, \
										  _bLastAction):

		(setPotentialWords, iRangeStart, iRangeEnd) =\
				self.compute_word_selection_range (_lstWords, _lstActions, _wc, _wu, _wp)
		setPotentialWords.discard (_wp)
		(dProb_WC_WU, dProb_WP, dProb_C, dProb_U) = _lstProbs
		(dNextProb_WC_WU, x1, x2, x3) = _lstNextProbs

		assert (None != _u)
		setWU = set ()
		for w in setPotentialWords:
			if 0 == len (filter (lambda x: None != x, dProb_U [w])):
				continue
			setWU.add (w)

		iWpForRangeCalc = _wp
		iOptions = 0
		mapPotentialActions = {}
		for wc in setPotentialWords:
			if None == _wp:
				iWpForRangeCalc = wc

			dNextProb_WU = dNextProb_WC_WU [wc]

			for wu in setWU:
				if wu == wc:
					continue
				pU = dProb_U [wu][_u]
				if None == pU:
					continue
				pWCWU = dProb_WC_WU [wc][wu]
				if None == pWCWU:
					continue
				pC = dProb_C [wc][wu][_u][_c]
				if None == pC:
					continue

				if True == _bLastAction:
					iFirstWord = min (wc, wu, iWpForRangeCalc)
					if iFirstWord > iRangeStart:
						if 0 < len (filter (lambda x: None != x, dNextProb_WU [iRangeStart:iFirstWord])):
							continue
					iLastWord = max (wc, wu, iWpForRangeCalc)
					if iLastWord < iRangeEnd:
						if 0 < len (filter (lambda x: None != x, dNextProb_WU [iLastWord + 1:iRangeEnd + 1])):
							continue

				dActionLogProb = pU + pC

				iOptions += 1
				lstOptions = mapPotentialActions.get (dActionLogProb, None)
				if None == lstOptions:
					mapPotentialActions [dActionLogProb] = [(wc, wu, _wp, _c, _u, _a)]
				else:
					lstOptions.append ((wc, wu, _wp, _c, _u, _a))

		return (mapPotentialActions, iOptions)




	# 															
	def tree_to_list (self, _lstTree):
		if 0 == len (_lstTree):
			return []
		if 1 == len (_lstTree):
			return map (lambda x: [x], _lstTree [0])

		lstList = []
		for x in _lstTree [0]:
			for y in self.tree_to_list (_lstTree [1:]):
				lstActions = [x]
				lstActions.extend (y)
				lstList.append (lstActions)
		return lstList




	# 															
	def compute_alternate_interpretations (self, _oArticle):

		iPotentialInterpretations = 1
		lstActionOptions = []
		for lstWords, lstActions, lstSentenceProbabilities \
				in zip (_oArticle.lst_Instructions, self.lst_Actions, self.lst_Probabilities):

			if 0 == len (lstActions):
				break
			lstActionOptions.append ([])
			for n, ((wc, wu, wp, c, u, a), lstProb) in enumerate (zip (lstActions, lstSentenceProbabilities)):
				bLastAction = (n + 1 == len (lstActions))

				lstNextProb = lstProb
				if len (lstSentenceProbabilities) > n + 1:
					lstNextProb = lstSentenceProbabilities [n+1]
				(mapAlternate, iOptions) = self.compute_alternate_word_selection (lstWords, lstActions, \
																				  lstProb, lstNextProb, \
																				  wc, wu, wp, c, u, a, \
																				  bLastAction)
				lstActionOptions [-1].append ([mapAlternate, iOptions])
				iPotentialInterpretations *= iOptions

		if iPotentialInterpretations > self.i_MaxAlternates:
			# get list of actions sorted by probability ...	
			mapProbabilityToMapAlternates = {}
			for lstSentenceActionOptions in lstActionOptions:
				for tplAlternateOptions in lstSentenceActionOptions:
					for dProb in tplAlternateOptions [0].keys ():
						lstMapAlternates = mapProbabilityToMapAlternates.get (dProb, None)
						if None == lstMapAlternates:
							mapProbabilityToMapAlternates [dProb] = [tplAlternateOptions]
						else:
							lstMapAlternates.append (tplAlternateOptions)


			# check and prune actions options from the least probably ...	
			lstActionProbs = mapProbabilityToMapAlternates.keys ()
			lstActionProbs.sort ()

			while iPotentialInterpretations > self.i_MaxAlternates + 100:
				# prune lowest probability actions ...				
				dMinProb = lstActionProbs [0]
				lstMapAlternates = mapProbabilityToMapAlternates [dMinProb]
				bOptionsModified = False
				for tplAlternateOptions in lstMapAlternates:

					# if there's only one option for a given action, 
					# we shouldn't remove it!						 
					iOptions = tplAlternateOptions [1]
					if 1 == iOptions:
						continue

					bOptionsModified = True
					lstAlternate = tplAlternateOptions [0][dMinProb]
					iCount = len (lstAlternate)

					# check if we should prune this whole list ...	
					if (iOptions > iCount) and \
						(1.0 * iPotentialInterpretations * (iOptions - iCount) / iOptions > self.i_MaxAlternates):
						# prune the whole list !					
						del tplAlternateOptions [0][dMinProb]
						tplAlternateOptions [1] -= iCount
						iPotentialInterpretations = iPotentialInterpretations * (iOptions - iCount) / iOptions

						lstMapAlternates.remove (tplAlternateOptions)
						if 0 == len (lstMapAlternates):
							del mapProbabilityToMapAlternates [dMinProb]
							lstActionProbs.pop (0)

					else:
						if len (lstAlternate) > 1:
							random.shuffle (lstAlternate)
						lstAlternate.pop ()
						tplAlternateOptions [1] -= 1
						iPotentialInterpretations = iPotentialInterpretations * (iOptions - 1) / iOptions

					# check if we're now below the max limit ...	
					iRecompute = 1
					for lstSentenceActionOptions in lstActionOptions:
						for (mapAlternate, iOptions) in lstSentenceActionOptions:
							iRecompute *= iOptions
					assert (iRecompute == iPotentialInterpretations)
					if iPotentialInterpretations <= self.i_MaxAlternates + 100:
						break

				if False == bOptionsModified:
					del mapProbabilityToMapAlternates [dMinProb]
					lstActionProbs.pop (0)

				if iPotentialInterpretations <= self.i_MaxAlternates + 100:
					break


		# convert action options to interpretation options ...	
		lstPotentialDocumentActions = []
		for lstSentenceActionOptions in lstActionOptions:
			lstPotentialSentenceActions = []
			for (mapAlternate, iOptions) in lstSentenceActionOptions:
				lstCommandActions = []
				for lst in mapAlternate.values ():
					lstCommandActions.extend (lst)
				lstPotentialSentenceActions.append (lstCommandActions)

			lstSentenceInterpretations = self.tree_to_list (lstPotentialSentenceActions)
			lstPotentialDocumentActions.append (lstSentenceInterpretations)

		lstPotentialInterpretations = self.tree_to_list (lstPotentialDocumentActions)
		return lstPotentialInterpretations


	
	# 															
	def get_environment_state (self):
		(lstState, bHasVisibleObject) = measure_state (None, self.set_TouchedObjects)	
		if None == bHasVisibleObject:
			return False

		self.set_environment_state (lstState)
		return True



	# 															
	def set_environment_state (self, _lstState):
		self.lst_CurrentState = _lstState
		self.map_WordsInEnvironment = {}

		self.i_CurrentStateObjectCount = len (self.lst_CurrentState)
		self.o_NoneObject.i_Index = len (self.lst_CurrentState)
		self.lst_CurrentStateIncludingNoneObject = list (self.lst_CurrentState)
		self.lst_CurrentStateIncludingNoneObject.append (self.o_NoneObject)




	# 															
	def print_selections (self):
		sCommand = '(none)'
		if None != self.o_SelectedCommand:
			sCommand = self.o_SelectedCommand

		sLog =	'         v:' +\
				self.lst_CurrentInstructionWords [self.i_SelectedCommandWordLocation] + '  (' +\
				sCommand + ')  o:' +\
				self.lst_CurrentInstructionWords [self.i_SelectedObjectWordLocation] + '  pp:' +\
				str (self.i_SelectedParameterPresence)

		if 0 != self.i_SelectedParameterPresence:
			sLog = sLog + '  p:' + self.lst_CurrentInstructionWords [self.i_SelectedParameterWordLocation]
		sLog = sLog + '   ' + str (len (self.set_PotentialObjectWords))

		if True == self.b_Verbose:
			print sLog
		file_InteractionLog.write (sLog + '\n')




	# 															
	def print_action (self):
		sLog = self.o_SelectedCommand
		if None != self.o_SelectedObject:
			sLog = sLog + ' (' + self.o_SelectedObject.s_ID +\
					') [' + self.o_SelectedObject.s_ObjectClass +\
					'] ' + self.o_SelectedObject.s_Name
		if None != self.i_SelectedParameterWordLocation:
			sLog = sLog + '  "' + self.lst_CurrentInstructionWords [self.i_SelectedParameterWordLocation] + '"'

		
		if True == self.b_Verbose:
			print '           - ' + sLog
		file_InteractionLog.write ('           - ' + sLog + '\n')
		file_InteractionLog.flush ()




	# 															
	def print_word_sequence (self, _oArticle):

		print
		file_InteractionLog.write ('\n')
		for lstWords, lstActions in zip (_oArticle.lst_Instructions, self.lst_Actions):

			if 0 == len (lstActions):
				break
			lstHilighedWords = list (lstWords)
			for i, (wc, wu, wp, c, u, a) in enumerate (lstActions):
				lstHilighedWords [wc] = '[c' + str(i) + ' ' + lstHilighedWords [wc] + ']'
				lstHilighedWords [wu] = '[u' + str(i) + ' ' + lstHilighedWords [wu] + ']'
				if None != wp:
					lstHilighedWords [wp] = '[p' + str(i) + ' ' + lstHilighedWords [wp] + ']'

			print '      ' + ' '.join (lstHilighedWords)
			file_InteractionLog.write ('      ' + ' '.join (lstHilighedWords) + '\n')
		print
		file_InteractionLog.write ('\n')





