	# 															
	def compute_action_log_probability (self):

		wc = self.i_SelectedCommandWordLocation
		wu = self.i_SelectedObjectWordLocation
		wp = self.i_SelectedParameterWordLocation
		c = self.i_SelectedCommandIndex
		u = self.i_SelectedObjectIndex

		pLogWCWU = self.d_Prob_WC_WU [wc][wu]
		if None == pLogWCWU:
			pLogWCWU = -1000000
		pLogC    = self.d_Prob_C [wc][wu][u][c]
		if None == pLogC:
			pLogC = -1000000
		pLogU    = self.d_Prob_U [wu][u]
		if None == pLogU:
			pLogU = -1000000

		if None == wp:
			return pLogWCWU + pLogC + pLogU

		if None == self.d_Prob_WP [wp]:
			return -1000000
		pLogWP = math.log (self.d_Prob_WP [wp]) 
		return pLogWCWU + pLogC + pLogU + pLogWP




	# compute p(a|.)											
	def compute_prob_and_sample_action (self, _oArticle, _iSentence):
		if False == self.compute_p_wc_wu (_oArticle, _iSentence):
			file_InteractionLog.write ('      ------ compute_p_wc_wu() = False \n')
			return False
		self.compute_p_u ()
		self.compute_p_c ()

		if False == self.sample_wc_wu_u_c ():
			file_InteractionLog.write ('      ------ sample_p_wc_wu() = False \n')
			return False

		if 1 == self.i_SelectedParameterPresence:
			while False == self.compute_p_wp ():
				self.d_Prob_WC_WU [self.i_SelectedCommandWordLocation]\
									[self.i_SelectedObjectWordLocation] = None
				if False == self.sample_wc_wu_u_c ():
					file_InteractionLog.write ('      ------ sample_p_wc_wu() = False \n')
					return False

			self.sample_wp ()
		else:
			self.i_SelectedParameterWordLocation = None

		return True




	#															
	def is_valid_combination (self, _w1, _w2):
		for w in self.lst_PreviouslyUsedCommandWords:
			if (_w1 - w)*(_w2 - w) < 0:
				return False
		return True



	#															
	def compute_p_wc_wu (self, _oArticle, _iSentence):
		# p(wc, wu|.)
		self.d_Features_WC_WU = [[]] * self.i_CurrentInstructionLength
		self.d_Prob_WC_WU = [[]] * self.i_CurrentInstructionLength

		dNormalization = 0.0
		for lwc in self.set_UnusedWordLocations:

			# the +1 below is to allow selection of [[none]] as the object word	
			self.d_Features_WC_WU [lwc] = [[]] * (self.i_CurrentInstructionLength + 1)
			self.d_Prob_WC_WU [lwc] = [None] * (self.i_CurrentInstructionLength + 1)

			dProb_WC_WU_lwc = self.d_Prob_WC_WU [lwc]

			for lwu in self.set_PotentialObjectWords:
				if lwu == lwc:
					continue
				if False == self.is_valid_combination (lwc, lwu):
					continue
				p = self.compute_score_wc_wu (lwc, lwu)
				dProb_WC_WU_lwc [lwu] = p
				dNormalization = dNormalization + math.exp (p)

			# probability of selecting [[none]] as the object word ...
			p = self.compute_score_wc_wu (lwc, self.i_CurrentInstructionLength)
			dProb_WC_WU_lwc[self.i_CurrentInstructionLength] = p
			dNormalization = dNormalization + math.exp (p)


		# set the probs of the lwc where the words are not in the 	
		# sentence to 0.0											
		for i, x in enumerate (self.d_Prob_WC_WU):
			if 0 == len (x):
				self.d_Prob_WC_WU [i] = [None] * (self.i_CurrentInstructionLength + 1)


		# normalization needs to be over WU*WC	
		if 0 != dNormalization:
			dLogNormalization = math.log (dNormalization)
			for lwc in self.set_UnusedWordLocations:
				dProb_WC_WU_lwc = self.d_Prob_WC_WU [lwc]
				for lwu in self.set_PotentialObjectWords:
					if None != dProb_WC_WU_lwc [lwu]:
						dProb_WC_WU_lwc [lwu] = dProb_WC_WU_lwc [lwu] - dLogNormalization
				dProb_WC_WU_lwc [self.i_CurrentInstructionLength] =\
						 dProb_WC_WU_lwc [self.i_CurrentInstructionLength] - dLogNormalization
		else:
			return False

		return True

	


	#															
	def compute_p_u (self):
		# p(u|., wu)
		self.d_Features_U = [[]] * (self.i_CurrentInstructionLength + 1)
		self.d_Prob_U = [[]] * (self.i_CurrentInstructionLength + 1)

		if 0 == len (self.map_WordToObjects):
			for lwu in xrange (self.i_CurrentInstructionLength):
				wu = self.lst_CurrentInstructionWords [lwu]
				self.map_WordToObjects [lwu] = []

				for i, u in enumerate (self.lst_CurrentState):
					# we assume that the word identified in the sentence is a 	
					# substring of the name of the UI object...					
					if True == self.word_maybe_object (wu, u):
						self.map_WordToObjects [lwu].append ((i, u))


		self.set_PotentiallyInteractableObjects = set ()
		for lwu in xrange (self.i_CurrentInstructionLength):
			self.d_Features_U [lwu] = [[]] * (self.i_CurrentStateObjectCount + 1)
			dProb = [None] * (self.i_CurrentStateObjectCount + 1)
		
			dNormalization = 0
			lstObjects = self.map_WordToObjects [lwu]
			for i, u in lstObjects:
				p = self.compute_score_u (lwu, u)
				dProb [i] = p
				self.set_PotentiallyInteractableObjects.add (u)
				dNormalization = dNormalization + math.exp (p)
			dProb [self.o_NoneObject.i_Index] = None

			self.d_Prob_U [lwu] = [None] * len (dProb)
			if 0 != dNormalization:
				dLogNormalization = math.log (dNormalization)
				for i, p in enumerate (dProb):
					if None == p:
						continue
					self.d_Prob_U [lwu][i] = p - dLogNormalization

		self.d_Prob_U [self.i_CurrentInstructionLength] = [None] * (self.i_CurrentStateObjectCount + 1)
		self.d_Prob_U [self.i_CurrentInstructionLength][self.o_NoneObject.i_Index] = 1





	#															
	def compute_p_c (self):
		# p(c|., wc, u)
		self.d_Features_C = [[]] * self.i_CurrentInstructionLength
		self.d_Prob_C = [[]] * self.i_CurrentInstructionLength

		for lwc in xrange (self.i_CurrentInstructionLength):
			assert (self.i_CurrentStateObjectCount + 1 == len (self.lst_CurrentStateIncludingNoneObject))
			self.d_Features_C [lwc] = [[]] * (self.i_CurrentInstructionLength + 1)
			self.d_Prob_C [lwc] = [[]] * (self.i_CurrentInstructionLength + 1)

			(setSelectableWords, x1, x2) = self.compute_word_selection_range (self.lst_CurrentInstructionWords, \
																	self.lst_Actions [-1], \
																	lwc, lwc, None)
			setSelectableWords.discard (self.i_CurrentInstructionLength)
			bEnoughWordsForParam = (len (setSelectableWords) > 2)

			for lwu in xrange (self.i_CurrentInstructionLength + 1):
				self.d_Features_C [lwc][lwu] = [[]] * (self.i_CurrentStateObjectCount + 1)
				self.d_Prob_C [lwc][lwu] = [[]] * (self.i_CurrentStateObjectCount + 1)

				for u in self.lst_CurrentStateIncludingNoneObject:
					self.d_Features_C [lwc][lwu][u.i_Index] = [[]] * self.i_CommandCount
					self.d_Prob_C [lwc][lwu][u.i_Index] = [None] * self.i_CommandCount

					if None == self.d_Prob_WC_WU [lwc][lwu]:
						continue
					if lwu not in self.set_PotentialObjectWords:
						continue
					if lwc not in self.set_UnusedWordLocations:
						continue
					if u not in self.set_PotentiallyInteractableObjects:
						continue

					dProb = [None] * self.i_CommandCount

					dNormalization = 0
					bValidObject = (self.o_NoneObject.i_Index != u.i_Index)
					for ic in xrange (self.i_CommandCount):	
						bValidCommand = (None != self.lst_AllCommands [ic])
						# not all combinations of command*object*parameter are valid ...
						bValidCombination = False
						bCommandNeedsParam = self.lst_CommandNeedsParam [ic]
						bCommandNeedsObject = self.lst_CommandNeedsObject [ic]

						if True == bValidCommand:
							if (True == bValidObject):
								bValidCombination = ((False == bCommandNeedsParam) or (True == bEnoughWordsForParam))
							elif ((False == bCommandNeedsObject) and \
									(True == bCommandNeedsParam) and \
									(True == bEnoughWordsForParam)):
								bValidCombination = True
						else:
							if False == bValidObject:
								bValidCombination = True

						if True == bValidCombination:
							p = self.compute_score_c (u, lwu, lwc, ic)
							dProb [ic] = p
							dNormalization = dNormalization + math.exp (p)


					if 0 != dNormalization:
						dLogNormalization = math.log (dNormalization)
						for i, p in enumerate (dProb):
							if None == p:
								continue
							self.d_Prob_C [lwc][lwu][u.i_Index][i] = p - dLogNormalization




	#															
	def compute_p_c_for_trace_walk (self, _lwc, _lwu, _ui, _u):
		# p(c|., wc, u)
		self.d_Features_C = [[]] * self.i_CurrentInstructionLength
		self.d_Prob_C = [[]] * self.i_CurrentInstructionLength

		swc = _lwc
		swu = _lwu
		ui = _ui

		self.d_Features_C [swc] = [[]] * (self.i_CurrentInstructionLength + 1)
		self.d_Prob_C [swc] = [[]] * (self.i_CurrentInstructionLength + 1)

		(setSelectableWords, x1, x2) = self.compute_word_selection_range (self.lst_CurrentInstructionWords, \
																self.lst_Actions [-1], \
																swc, swc, None)
		setSelectableWords.discard (self.i_CurrentInstructionLength)
		bEnoughWordsForParam = (len (setSelectableWords) > 2)

		self.d_Features_C [swc][swu] = [[]] * (self.i_CurrentStateObjectCount + 1)
		self.d_Prob_C [swc][swu] = [[]] * (self.i_CurrentStateObjectCount + 1)

		self.d_Features_C [swc][swu][ui] = [[]] * self.i_CommandCount
		self.d_Prob_C [swc][swu][ui] = [None] * self.i_CommandCount


		dProb = [None] * self.i_CommandCount

		dNormalization = 0
		bValidObject = (self.o_NoneObject.i_Index != ui)
		for ic in xrange (self.i_CommandCount):	
			bValidCommand = (None != self.lst_AllCommands [ic])
			# not all combinations of command*object*parameter are valid ...
			bValidCombination = False
			bCommandNeedsParam = self.lst_CommandNeedsParam [ic]
			bCommandNeedsObject = self.lst_CommandNeedsObject [ic]

			if True == bValidCommand:
				if (True == bValidObject):
					bValidCombination = ((False == bCommandNeedsParam) or (True == bEnoughWordsForParam))
				elif ((False == bCommandNeedsObject) and \
						(True == bCommandNeedsParam) and \
						(True == bEnoughWordsForParam)):
					bValidCombination = True
			else:
				if False == bValidObject:
					bValidCombination = True

			if True == bValidCombination:
				p = self.compute_score_c (_u, swu, swc, ic)
				dProb [ic] = p
				dNormalization = dNormalization + math.exp (p)


		if 0 != dNormalization:
			dLogNormalization = math.log (dNormalization)
			for i, p in enumerate (dProb):
				if None == p:
					continue
				self.d_Prob_C [swc][swu][ui][i] = p - dLogNormalization






	#															
	def compute_p_wp (self):
		# p(w|., wu, wc, bp)
		swu = self.i_SelectedObjectWordLocation
		swc = self.i_SelectedCommandWordLocation

		self.d_Features_WP = [[]] * self.i_CurrentInstructionLength
		dProb = [None] * self.i_CurrentInstructionLength

		dNormalization = 0
		for l in self.set_UnusedWordLocations:
			if False == self.is_valid_combination (swc, l):
				continue
			p = math.exp (self.compute_score_wp (swu, swc, l))
			dProb [l] = p
			dNormalization = dNormalization + p

		if swu < self.i_CurrentInstructionLength:
			if None != dProb [swu]:
				dNormalization = dNormalization - dProb [swu]
			dProb [swu] = None

		if None != dProb [swc]:
			dNormalization = dNormalization - dProb [swc]
		dProb [swc] = None
	

		self.d_Prob_WP = [None] * len (dProb)
		if 0 != dNormalization:
			for i, p in enumerate (dProb):
				if None != p:
					self.d_Prob_WP [i] = 1.0 * p / dNormalization
			return True
		else:
			return False
			assert (dProb != ([None] * len (dProb)))
			iCount = 0
			for l in self.set_UnusedWordLocations:
				if False == self.is_valid_combination (swc, l):
					continue
				iCount += 1
		
			self.d_Prob_WP = [None] * len (dProb)
			for l in self.set_UnusedWordLocations:
				if False == self.is_valid_combination (swc, l):
					continue
				self.d_Prob_WP [l] = 1.0 / iCount





	# 															
	def sample_from_cdf (self, _dCDF, _dPDF):
		assert (_dCDF [-1] >= _dPDF [-1])

		dUniform = random.uniform (0, _dCDF [-1])
		if dUniform == _dCDF [-1]:
			return len (_dCDF) - 1
		else:
			iSample = bisect.bisect_left (_dCDF, dUniform)

			# if we have 0's in _dPDF, the bisect above might return
			# an iSample where _dPDF [iSample] = 0!					
			# the code below is to handle this case...				
			iActualSample = iSample
			while 0 == _dPDF [iActualSample]:
				iActualSample = iActualSample + 1
				if iActualSample == len (_dPDF):
					iActualSample = None
					break
			if None == iActualSample:
				iActualSample = iSample
				while 0 == _dPDF [iActualSample]:
					iActualSample = iActualSample - 1
					if iActualSample < 0:
						iActualSample = None
						break

			if None == iActualSample:
				print '[ERROR] failed to sample from pdf.'
				file_InteractionLog.write ('[ERROR] failed to sample from pdf.\n')
				file_InteractionLog.write ('pdf : ' +  str (_dPDF) + '\n\n')
				file_InteractionLog.write ('cdf : ' + str (_dCDF) + '\n\n')
				file_InteractionLog.write ('original sample : ' + str (iSample) + '\n')

			return iActualSample





	#															
	def sample_from_pdf (self, _dPDF):

		# if we are in test mode, we always take the max probability action ...
		if True == self.b_TestMode:
			dMaxProb = max (_dPDF)

			dCDF = [0] * len (_dPDF)
			dPDF = [0] * len (_dPDF)
			if (None != _dPDF [0]) and (_dPDF [0] == dMaxProb):
				dCDF [0] = 1
				dPDF [0] = 1
			for i in xrange (1, len (_dPDF)):
				if (None == _dPDF [i]) or (_dPDF [i] < dMaxProb):
					dCDF [i] = dCDF [i-1]
				else:
					dCDF [i] = 1 + dCDF [i-1]
					dPDF [i] = 1

			iSample = self.sample_from_cdf (dCDF, dPDF)
			assert (0 != dPDF [iSample])
			assert (None != _dPDF [iSample])
			return iSample


		else:
			# If we are in training mode, we have to randomly sample.		
			# There are two ways of doing this:								
			#   1. The \epsilon greedy method								
			#   2. Sampling from a smoothed pdf								

			if True == self.b_EpsilonGreedy:
				# 1. \epsilog greedy sampling.								
				#    With probability \epsilon, we sample from a uniform	
				#    distribution, otherwise we take the max prob action.	
				dUniform = random.uniform (0, 1)

				if dUniform > self.d_SamplingEpsilon:
					# greedy sampling - find max prob, and uniformly	
					# sample from all cases equal to max prob...		

					dCDF = list (_dPDF)
					if None == dCDF [0]:
						dCDF [0] = 0
					for i in xrange (1, len (dCDF)):
						if None == dCDF [i]:
							dCDF [i] = 0
						dCDF [i] = dCDF [i] + dCDF [i-1]

					iSample = self.sample_from_cdf (dCDF, _dPDF)
					assert (None != _dPDF [iSample])
					return iSample


				else:
					# uniform sampling ...
					dCDF = [0] * len (_dPDF)
					dPDF = [0] * len (_dPDF)
					if None != _dPDF [0]:
						dCDF [0] = 1
						dPDF [0] = 1
					for i in xrange (1, len (_dPDF)):
						if None == _dPDF [i]:
							dCDF [i] = dCDF [i-1]
						else:
							dCDF [i] = 1 + dCDF [i-1]
							dPDF [i] = 1

					iSample = self.sample_from_cdf (dCDF, dPDF)
					assert (0 != dPDF [iSample])
					assert (None != _dPDF [iSample])
					return iSample


			else:
				# 2. Sampling from a smoothed pdf.  The pdf given to us	
				#    has already been smoothed, so we need to just 		
				#    sample from it...									
				dCDF = list (_dPDF)
				if None == dCDF [0]:
					dCDF [0] = 0
				for i in xrange (1, len (dCDF)):
					if None == dCDF [i]:
						dCDF [i] = 0
					dCDF [i] = dCDF [i] + dCDF [i-1]

				iSample = self.sample_from_cdf (dCDF, _dPDF)
				assert (None != _dPDF [iSample])
				return iSample





	# sample action based on p(a|.) = p(u|.)p(c|u,.)			
	def sample_wc_wu_u_c (self):
		# p(wc, wu|.) p(u|wu,.) p(c|wc,u,.)
		iLenWU = len (self.d_Prob_WC_WU [0])
		iLenU = len (self.d_Prob_U [0])
		iLenC = self.i_CommandCount
		assert (iLenC == len (self.d_Prob_C [0][0][0]))

		dPDF = [None] * (len (self.d_Prob_WC_WU) * iLenWU * iLenU * iLenC)
		i = 0
		iZeros = 0
		for lwc, dPdf_WC_WU in enumerate (self.d_Prob_WC_WU):
			for lwu, dProb_WC_WU in enumerate (dPdf_WC_WU):
				dProbC_lwc_lwu = self.d_Prob_C [lwc][lwu]
				if None == dProb_WC_WU:
					i = i + iLenU * iLenC
					iZeros = iZeros + iLenU * iLenC
					continue
				for ui, dProbU in enumerate (self.d_Prob_U [lwu]):
					if None == dProbU:
						i = i + iLenC
						iZeros = iZeros + iLenC
						continue
					for p in dProbC_lwc_lwu [ui]:
						if None == p:
							i = i + 1
							iZeros = iZeros + 1
							continue
						dSum = dProb_WC_WU + dProbU + p
						if dSum > 700:
							dSum = 700
						dPDF [i] = math.exp (dSum)
						if 0 == dPDF [i]:
							iZeros = iZeros + 1
						i = i + 1


		file_InteractionLog.write ('         zeros : ' + str (iZeros) + ' / ' + str (len (dPDF)) + '\n')
		if iZeros == len (dPDF):
			return False


		i_WC_WU_U_C = self.sample_from_pdf (dPDF)

		iDivisor = iLenWU * iLenU * iLenC
		# self.i_SelectedCommandWordLocation = i_WC_WU_U_C / iDivisor
		lwc = i_WC_WU_U_C / iDivisor
		iRemainder = i_WC_WU_U_C % iDivisor

		iDivisor = iLenU * iLenC
		# self.i_SelectedObjectWordLocation = iRemainder / iDivisor
		lwu = iRemainder / iDivisor
		iRemainder = iRemainder % iDivisor

		iDivisor = iLenC
		# self.i_SelectedObjectIndex = iRemainder / iDivisor
		u = iRemainder / iDivisor
		# self.i_SelectedCommandIndex = iRemainder % iDivisor
		c = iRemainder % iDivisor


		#												
		if dPDF [i_WC_WU_U_C] == None:
			file_InteractionLog.write ('[ERROR]  sample_wc_wu_u_c has selected action with probability None !\n')
		assert (dPDF [i_WC_WU_U_C] != None)

		self.set_selected_action (lwc, lwu, c, u)
		return True




	#																		
	def set_selected_action (self, _lwc, _lwu, _c, _u):
		self.i_SelectedCommandWordLocation = _lwc
		self.i_SelectedObjectWordLocation = _lwu
		self.i_SelectedCommandIndex = _c
		self.i_SelectedObjectIndex = _u

		if self.i_SelectedObjectIndex != self.o_NoneObject.i_Index:
			self.o_SelectedObject = self.lst_CurrentStateIncludingNoneObject [self.i_SelectedObjectIndex]
		else:
			self.o_SelectedObject = None
		self.o_SelectedCommand = self.lst_AllCommands [self.i_SelectedCommandIndex]

		self.i_SelectedParameterPresence = 0
		if None != self.o_SelectedCommand:
			if True == self.lst_CommandNeedsParam [self.i_SelectedCommandIndex]:
				self.i_SelectedParameterPresence = 1






	def sample_wp (self):
		if 0 != self.i_SelectedParameterPresence:
			self.i_SelectedParameterWordLocation = self.sample_from_pdf (self.d_Prob_WP)
			assert (None != self.d_Prob_WP [self.i_SelectedParameterWordLocation])
		else:
			self.i_SelectedParameterWordLocation = None


