
	#															
	def update_used_words_collections (self):
		self.lst_PreviouslyUsedWords.append (self.i_SelectedCommandWordLocation)
		self.lst_PreviouslyUsedCommandWords.append (self.i_SelectedCommandWordLocation)
		self.set_UnusedWordLocations.discard (self.i_SelectedCommandWordLocation)

		if None != self.i_SelectedObjectWordLocation:
			self.lst_PreviouslyUsedWords.append (self.i_SelectedObjectWordLocation)
			self.lst_PreviouslyUsedObjectWords.append (self.i_SelectedObjectWordLocation)
			self.set_UnusedWordLocations.discard (self.i_SelectedObjectWordLocation)
			if self.i_SelectedCommandWordLocation < self.i_SelectedObjectWordLocation:
				for i in xrange (self.i_SelectedCommandWordLocation, self.i_SelectedObjectWordLocation):
					self.set_UnusedWordLocations.discard (i)
			else:
				for i in xrange (self.i_SelectedObjectWordLocation, self.i_SelectedCommandWordLocation):
					self.set_UnusedWordLocations.discard (i)

		if None != self.i_SelectedParameterWordLocation:
			self.lst_PreviouslyUsedParamWords.append (self.i_SelectedParameterWordLocation)
			self.lst_PreviouslyUsedWords.append (self.i_SelectedParameterWordLocation)
			self.set_UnusedWordLocations.discard (self.i_SelectedParameterWordLocation)
			if self.i_SelectedCommandWordLocation < self.i_SelectedParameterWordLocation:
				for i in xrange (self.i_SelectedCommandWordLocation, self.i_SelectedParameterWordLocation):
					self.set_UnusedWordLocations.discard (i)
			else:
				for i in xrange (self.i_SelectedParameterWordLocation, self.i_SelectedCommandWordLocation):
					self.set_UnusedWordLocations.discard (i)
			if self.i_SelectedObjectWordLocation < self.i_SelectedParameterWordLocation:
				for i in xrange (self.i_SelectedObjectWordLocation, self.i_SelectedParameterWordLocation):
					self.set_UnusedWordLocations.discard (i)
			else:
				for i in xrange (self.i_SelectedParameterWordLocation, self.i_SelectedObjectWordLocation):
					self.set_UnusedWordLocations.discard (i)




	# initialize traces counts ...								
	def initialize_traces (self):
		self.d_Trace_WC_WU = []
		self.d_Trace_U = []
		self.d_Trace_C = []
		self.d_Trace_WP = []




	# update the trace counts ...								
	def update_traces (self, _iTimeStep):
		self.update_trace_wc_wu (_iTimeStep)
		self.update_trace_u (_iTimeStep)
		self.update_trace_c (_iTimeStep)
		self.update_trace_wp (_iTimeStep)




	#															
	def update_trace_wc_wu (self, _iTimeStep):
		# p(w|.)
		if len (self.d_Trace_WC_WU) < _iTimeStep + 1:
			self.d_Trace_WC_WU.append ([0.0] * self.i_FeatureCount_WC_WU)
		assert (len (self.d_Trace_WC_WU) == _iTimeStep + 1)

		swc = self.i_SelectedCommandWordLocation
		swu = self.i_SelectedObjectWordLocation


		dSum = [0] * self.i_FeatureCount_WC_WU
		for lwu in self.set_PotentialObjectWords:
			for lwc in self.set_UnusedWordLocations:
				if lwc == lwu:
					continue
				if False == self.is_valid_combination (lwc, lwu):
					continue
				dFeatures_lwc_lwu = self.d_Features_WC_WU [lwc][lwu]
				dProb = math.exp (self.d_Prob_WC_WU [lwc][lwu])
				for k in xrange (self.i_FeatureCount_WC_WU):
					if 0 != dFeatures_lwc_lwu [k]:
						dSum [k] = dSum [k] + dFeatures_lwc_lwu [k] * dProb

		
		dTrace_t = self.d_Trace_WC_WU [_iTimeStep]
		dFeatures_swc_swu = self.d_Features_WC_WU [swc][swu]
		for k in xrange (self.i_FeatureCount_WC_WU):
			dDiff = dFeatures_swc_swu [k] - dSum [k]
			if 0 != dDiff:
				dTrace_t [k] = dTrace_t [k] + dDiff





	#															
	def update_trace_u (self, _iTimeStep):
		# p(u|., wu)
		if len (self.d_Trace_U) < _iTimeStep + 1:
			self.d_Trace_U.append ([0.0] * self.i_FeatureCount_U)
		assert (len (self.d_Trace_U) == _iTimeStep + 1)

		# if [[none]] was selected as the object word, then no object selection was done,	
		# so we should not update the traces for U											
		if None == self.o_SelectedObject:
			return

		swu = self.i_SelectedObjectWordLocation

		dSum = [0] * self.i_FeatureCount_U
		for iu in xrange (self.i_CurrentStateObjectCount):
			# only objects containing WU in their names are processed 		
			# for features. Others have prob = 0. So we have to skip them.	
			if len (self.d_Features_U [swu][iu]) > 0:
				dFeatures_swu_iu = self.d_Features_U [swu][iu]
				dProb = math.exp (self.d_Prob_U [swu][iu])
				for k in xrange (self.i_FeatureCount_U):
					dSum [k] = dSum [k] + dFeatures_swu_iu [k] * dProb

		dTrace_t = self.d_Trace_U [_iTimeStep]
		dFeatures_swu_siu = self.d_Features_U [swu][self.i_SelectedObjectIndex]
		for k in xrange (self.i_FeatureCount_U):
			dTrace_t [k] = dTrace_t [k] + (dFeatures_swu_siu [k] - dSum [k])





	#															
	def update_trace_c (self, _iTimeStep):
		# p(c|., wc)
		if len (self.d_Trace_C) < _iTimeStep + 1:
			self.d_Trace_C.append ([0.0] * self.i_FeatureCount_C)
		assert (len (self.d_Trace_C) == _iTimeStep + 1)

		swc = self.i_SelectedCommandWordLocation
		swu = self.i_SelectedObjectWordLocation
		ui = self.o_NoneObject.i_Index
		if None != self.o_SelectedObject:
			ui = self.o_SelectedObject.i_Index


		dSum = [0] * self.i_FeatureCount_C
		for ic in xrange (self.i_CommandCount):
			if len (self.d_Features_C [swc][swu][ui][ic]) == 0:
				continue
			if (ui == self.o_NoneObject.i_Index) and (self.lst_CommandNeedsObject [ic]):
				continue
			dFeatures_swc_ui_ic = self.d_Features_C [swc][swu][ui][ic]
			dProb = math.exp (self.d_Prob_C [swc][swu][ui][ic])
			for k in xrange (self.i_FeatureCount_C):
				dSum [k] = dSum [k] + dFeatures_swc_ui_ic [k] * dProb

		dTrace_t = self.d_Trace_C [_iTimeStep]
		dFeatures_swc_sui_sic = self.d_Features_C [swc][swu][ui][self.i_SelectedCommandIndex]
		for k in xrange (self.i_FeatureCount_C):
			dTrace_t [k] = dTrace_t [k] + (dFeatures_swc_sui_sic [k] - dSum [k])





	#															
	def update_trace_wp (self, _iTimeStep):
		# p(wp|., wu, wc, b)
		if len (self.d_Trace_WP) < _iTimeStep + 1:
			self.d_Trace_WP.append ([0.0] * self.i_FeatureCount_WP)
		assert (len (self.d_Trace_WP) == _iTimeStep + 1)

		if None == self.i_SelectedParameterWordLocation:
			return

		swu = self.i_SelectedObjectWordLocation
		swc = self.i_SelectedCommandWordLocation


		dSum = [0] * self.i_FeatureCount_WP
		for w in self.set_UnusedWordLocations:
			if (w == swu) or (w == swc):
				continue
			if False == self.is_valid_combination (swc, w):
				continue
			dFeatures_w = self.d_Features_WP [w]
			dProb = self.d_Prob_WP [w]
			for k in xrange (self.i_FeatureCount_WP):
				dSum [k] = dSum [k] + dFeatures_w [k] * dProb

		dTrace_t = self.d_Trace_WP [_iTimeStep]
		dFeatures_sw = self.d_Features_WP [self.i_SelectedParameterWordLocation]
		for k in xrange (self.i_FeatureCount_WP):
			dTrace_t [k] = dTrace_t [k] + (dFeatures_sw [k] - dSum [k])





	# update feature weights by:								
	#    \theta  = \theta  + \alpha        * R      * \Lambda	
	#    weights = weights + learning_rate * reward * trace		
	def compute_weight_update (self, _dReward):
		self.compute_weight_update_wc_wu (_dReward)
		self.compute_weight_update_u (_dReward)
		self.compute_weight_update_c (_dReward)
		self.compute_weight_update_wp (_dReward)


		if self.d_NegativeRewardMultiplierMin < self.d_NegativeRewardMultiplierMax:
			dTotalReward = sum (_dReward)
			if dTotalReward > 0:
				self.lst_PositiveReward.append (dTotalReward)
			elif dTotalReward < 0:
				self.lst_NegativeReward.append (dTotalReward)

	



	#															
	def compute_weight_update_wc_wu (self, _dReward):
		for n in xrange (len (self.d_Trace_WC_WU) - 1, 0, -1):
			dTracePrev = self.d_Trace_WC_WU [n - 1]
			dTrace = self.d_Trace_WC_WU [n]
			for i, t in enumerate (dTrace):
				dTracePrev [i] += t
			
		dUpdate = [0.0] * len (self.d_Weights_WC_WU)
		for timestep, r in enumerate (_dReward):
			dTrace = self.d_Trace_WC_WU [timestep]
			for i, t in enumerate (dTrace):
				if 0 != t:
					dUpdate [i] = dUpdate [i] + t * r

		if None == self.d_WeightUpdates_WC_WU:
			self.d_WeightUpdates_WC_WU = [0.0] * len (dUpdate)

		for i, u in enumerate (dUpdate):
			if 0 != u:
				self.d_WeightUpdates_WC_WU [i] = self.d_WeightUpdates_WC_WU [i] + u * self.d_LearningRate





	#															
	def compute_weight_update_u (self, _dReward):
		# compute cumulative update to weights_u from the 	
		# traces & rewards at each timestep ...				
		for n in xrange (len (self.d_Trace_U) - 1, 0, -1):
			dTracePrev = self.d_Trace_U [n - 1]
			dTrace = self.d_Trace_U [n]
			for i, t in enumerate (dTrace):
				dTracePrev [i] += t

		dUpdate = [0.0] * len (self.d_Weights_U)
		for timestep, r in enumerate (_dReward):
			for i, (u, t) in enumerate (zip (dUpdate, self.d_Trace_U [timestep])):
				dUpdate [i] = u + t * r

		if None == self.d_WeightUpdates_U:
			self.d_WeightUpdates_U = [0.0] * len (dUpdate)

		for i, (w, u) in enumerate (zip (self.d_WeightUpdates_U, dUpdate)):
			self.d_WeightUpdates_U [i] = w + u * self.d_LearningRate



	

	#															
	def compute_weight_update_c (self, _dReward):
		# compute cumulative update to weights_u from the 	
		# traces & rewards at each timestep ...				
		for n in xrange (len (self.d_Trace_C) - 1, 0, -1):
			dTracePrev = self.d_Trace_C [n - 1]
			dTrace = self.d_Trace_C [n]
			for i, t in enumerate (dTrace):
				dTracePrev [i] += t

		dUpdate = [0.0] * len (self.d_Weights_C)
		for timestep, r in enumerate (_dReward):
			for i, (u, t) in enumerate (zip (dUpdate, self.d_Trace_C [timestep])):
				dUpdate [i] = u + t * r

		if None == self.d_WeightUpdates_C:
			self.d_WeightUpdates_C = [0.0] * len (dUpdate)

		for i, (w, u) in enumerate (zip (self.d_WeightUpdates_C, dUpdate)):
			self.d_WeightUpdates_C [i] = w + u * self.d_LearningRate





	#															
	def compute_weight_update_wp (self, _dReward):
		for n in xrange (len (self.d_Trace_WP) - 1, 0, -1):
			dTracePrev = self.d_Trace_WP [n - 1]
			dTrace = self.d_Trace_WP [n]
			for i, t in enumerate (dTrace):
				dTracePrev [i] += t

		dUpdate = [0.0] * len (self.d_Weights_WP)
		for timestep, r in enumerate (_dReward):
			for i, (u, t) in enumerate (zip (dUpdate, self.d_Trace_WP [timestep])):
				dUpdate [i] = u + t * r

		if None == self.d_WeightUpdates_WP:
			self.d_WeightUpdates_WP = [0.0] * len (dUpdate)

		for i, (w, u) in enumerate (zip (self.d_WeightUpdates_WP, dUpdate)):
			self.d_WeightUpdates_WP [i] = w + u * self.d_LearningRate





	#															
	def update_weights (self):
		if None != self.d_WeightUpdates_WC_WU:
			for i, (w, u) in enumerate (zip (self.d_Weights_WC_WU, self.d_WeightUpdates_WC_WU)):
				if 0 != u:
					self.d_Weights_WC_WU [i] = w + u

		if None != self.d_WeightUpdates_U:
			for i, (w, u) in enumerate (zip (self.d_Weights_U, self.d_WeightUpdates_U)):
				if 0 != u:
					self.d_Weights_U [i] = w + u

		if None != self.d_WeightUpdates_C:
			for i, (w, u) in enumerate (zip (self.d_Weights_C, self.d_WeightUpdates_C)):
				if 0 != u:
					self.d_Weights_C [i] = w + u

		if None != self.d_WeightUpdates_WP:
			for i, (w, u) in enumerate (zip (self.d_Weights_WP, self.d_WeightUpdates_WP)):
				if 0 != u:
					self.d_Weights_WP [i] = w + u

		self.d_WeightUpdates_WC_WU = None
		self.d_WeightUpdates_U = None
		self.d_WeightUpdates_C = None
		self.d_WeightUpdates_WP = None

		self.d_AverageWeights_WC_WU = 1.0 * sum (self.d_Weights_WC_WU) / len (self.d_Weights_WC_WU)
		self.d_AverageWeights_U = 1.0 * sum (self.d_Weights_U) / len (self.d_Weights_U)
		self.d_AverageWeights_C = 1.0 * sum (self.d_Weights_C) / len (self.d_Weights_C)
		self.d_AverageWeights_WP = 1.0 * sum (self.d_Weights_WP) / len (self.d_Weights_WP)


		# update negative multiplier to keep negative & positive rewards somewhat balanced ...
		if self.d_NegativeRewardMultiplierMin < self.d_NegativeRewardMultiplierMax:

			dTotalPositiveReward = sum (self.lst_PositiveReward)
			dTotalNegativeReward = sum (self.lst_NegativeReward)

			if dTotalPositiveReward == 0:
				self.d_NegativeRewardMultiplier = self.d_NegativeRewardMultiplierMin

			elif dTotalNegativeReward != 0:
				dUpdateRatio = -1.0 * dTotalPositiveReward / dTotalNegativeReward
				self.d_NegativeRewardMultiplier = 0.5 * (1 + dUpdateRatio) * self.d_NegativeRewardMultiplier
				if self.d_NegativeRewardMultiplier < self.d_NegativeRewardMultiplierMin:
					self.d_NegativeRewardMultiplier = self.d_NegativeRewardMultiplierMin
				if self.d_NegativeRewardMultiplier > self.d_NegativeRewardMultiplierMax:
					self.d_NegativeRewardMultiplier = self.d_NegativeRewardMultiplierMax

			self.lst_PositiveReward = []
			self.lst_NegativeReward = []

			# file_InteractionLog.write ('      negative reward multiplier : ' + str (self.d_NegativeRewardMultiplier) + '\n')
			# print '      negative reward multiplier : ' + str (self.d_NegativeRewardMultiplier)




