import re
rgx_NonAlnum = re.compile ('[^a-zA-Z0-9]+')
map_TextToDistance = {}


def normalized_alnum_edit_distance (_sLeft, _sRight):
	sText1 = _sLeft + '\xff' + _sRight
	dCachedDistance = map_TextToDistance.get (sText1, None)
	if None != dCachedDistance:
		return dCachedDistance
	sText2 = _sRight + '\xff' + _sLeft
	dCachedDistance = map_TextToDistance.get (sText2, None)
	if None != dCachedDistance:
		return dCachedDistance

	left = rgx_NonAlnum.sub ('', _sLeft)
	right = rgx_NonAlnum.sub ('', _sRight)
	
	dNormalized = normalized_string_edit_distance (left, right)
	map_TextToDistance [sText1] = dNormalized
	map_TextToDistance [sText2] = dNormalized

	return dNormalized



def normalized_string_edit_distance (_sLeft, _sRight):

	iLengthLeft = len (_sLeft) + 1
	iLengthRight = len (_sRight) + 1

	d = [None] * (iLengthLeft * iLengthRight)
	for l in xrange (iLengthLeft):
		d [l * iLengthRight] = l
	for r in xrange (iLengthRight):
		d [r] = r
	
	for l in xrange (1, iLengthLeft):
		for r in xrange (1, iLengthRight):
			a = d [(l-1) * iLengthRight +  r ] + 1
			b = d [  l   * iLengthRight + r-1] + 1
			c = d [(l-1) * iLengthRight + r-1]
			if _sLeft [l-1] != _sRight [r-1]:
				c = c + 1

			if a > b:
				a = b
			if a > c:
				a = c
			d [l * iLengthRight + r] = a
	
	dLen = max (len (_sLeft), len (_sRight))
	if 0 == dLen:
		return 1
	dNormalized = 1.0 * d [iLengthLeft * iLengthRight - 1] / dLen

	return dNormalized


print normalized_alnum_edit_distance ('secondary ide channel', 'secondary')
#print normalized_alnum_edit_distance ('control panel', 'panel')
#print normalized_alnum_edit_distance ('ok', 'on')
#print normalized_alnum_edit_distance ('tab', 'fax')
#print normalized_alnum_edit_distance ('internet explorer', 'internet')
#print normalized_alnum_edit_distance ('internet explorer', 'explorer')
#print normalized_alnum_edit_distance ('accessibility', 'accessability')
#print normalized_alnum_edit_distance ('overwrite as needed', 'overwrite events as needed')
#print normalized_alnum_edit_distance ('ppp: windows 95/98/nt/2000  internet', 'ppp: windows 95/98/nt4/2000, internet')
#print normalized_alnum_edit_distance ('file and print sharing for', 'file and printer sharing for')
#print normalized_alnum_edit_distance ('show internet explorer on desktop', 'show internet explorer on the desktop')
#print normalized_alnum_edit_distance ('this computer is for home use and not part of a business network',\
#									  'this computer is for home use and is not part of a business network')
