

o_CacheInterface = None
soc_Client = None
soc_VMClient = None
file_InteractionLog = None
map_StartingEnvToArticle = {}
set_HeldoutArticles = set ()
i_TotalArticles = 0



#													
def get_words (_sLine):
	sLine = _sLine

	sCleanLine = ''
	iLast = 0
	iStart = sLine.find ('<b>')
	while -1 != iStart:
		iEnd = sLine.find ('</b>', iStart)
		assert (-1 != iEnd)

		sCleanLine = sCleanLine + sLine [iLast:iStart]
		iLast = iEnd
		for i in xrange (iStart, iEnd):
			if ' ' == sLine [i]:
				sCleanLine = sCleanLine + '\x01'
			else:
				sCleanLine = sCleanLine + sLine [i]
		iStart = sLine.find ('<b>', iEnd)

	sCleanLine = sCleanLine + sLine [iLast:]

	sCleanLine = sCleanLine.replace ('</b>', ' ')
	sCleanLine = sCleanLine.replace ('<b>', '\x02')
	return sCleanLine.split ()



#													
def load_heldout_articles ():
	print '   loading heldout artiles ...'
	global set_HeldoutArticles

	sHeldoutFile = get_config ('heldout_file')
	if '' == sHeldoutFile:
		return

	file = open (sHeldoutFile)
	lstLines = file.readlines ()
	file.close ()

	for sLine in lstLines:
		set_HeldoutArticles.add (sLine.strip ())

	print '      ' + str (len (set_HeldoutArticles)) + ' heldout articles'



#													
def load_articles ():
	print '   loading articles ...'
	global map_StartingEnvToArticle

	setIgnore = set ()
	file = open (get_config ('ignore_list_file'))
	for sLine in file.readlines ():
		sID = sLine.split ()[0].strip ()
		setIgnore.add (sID)
	file.close ()

	map_StartingEnvToArticle = {}
	# sArticlePickleFile  = get_config ('article_cache_file')
	# if True == os.access (sArticlePickleFile, os.R_OK):
	#	file = open (get_config ('article_cache_file'))
	#	mapStartingEnvToArticle = cPickle.load (file)
	#	file.close ()
	#
	#	for sStartingState, lstArticles in mapStartingEnvToArticle.items ():
	#		map_StartingEnvToArticle [sStartingState] = []
	#		for oArticle in lstArticles:
	#			if oArticle.i_ID in setIgnore:
	#				continue
	#			map_StartingEnvToArticle [sStartingState].append (oArticle)
	#
	#	iArticles = 0
	#	for lstArticles in map_StartingEnvToArticle.values ():
	#		iArticles = iArticles + len (lstArticles)
	#	return iArticles


	file = open (get_config ('article_file'))
	lstLines = file.readlines ()
	file.close ()

	sObjectMarker = '\x02'

	iIndex = 0
	iID = None
	oArticle = None
	for sLine in lstLines:
		sLine = sLine.strip ()

		if (len (sLine) > 0) and ('#' == sLine [0]):
			lstValues = sLine.split ()
			if True == lstValues [1].replace ('-','').isdigit ():
				iID = lstValues [1]
			continue

		sLine = sLine.replace (',', ' ')
		sLine = sLine.strip ()
		if '' == sLine:
			if None != oArticle:
				assert (None != oArticle.s_RequiredStartingEnvState)
				if None == map_StartingEnvToArticle.get (oArticle.s_RequiredStartingEnvState, None):
					map_StartingEnvToArticle [oArticle.s_RequiredStartingEnvState] = []
				map_StartingEnvToArticle [oArticle.s_RequiredStartingEnvState].append (oArticle)
			oArticle = None
			continue
		
		if None == oArticle:
			oArticle = Article ()
			oArticle.i_Index = iIndex
			oArticle.i_ID = iID
			iIndex = iIndex + 1

		if '@' == sLine [0]:
			oArticle.s_RequiredStartingEnvState = sLine [1:].strip ()
			continue

		sLine = sLine.lower ()
		lstRawWords = []
		for sWord in get_words (sLine):
			lstRawWords.append (sWord.strip ().replace ('\x01', ' ').strip ())

		lstWords = []
		for sWord in lstRawWords:
			lstWords.append (sWord.replace (sObjectMarker, '').strip ())

		oArticle.lst_Instructions.append (lstWords)

		iWords = len (lstWords)
	
	if None != oArticle:
		assert (None != oArticle.s_RequiredStartingEnvState)
		if None == map_StartingEnvToArticle.get (oArticle.s_RequiredStartingEnvState, None):
			map_StartingEnvToArticle [oArticle.s_RequiredStartingEnvState] = []
		map_StartingEnvToArticle [oArticle.s_RequiredStartingEnvState].append (oArticle)

	print '      ' + str (iIndex) + ' articles.'
	return iIndex



#													
def main (_bTestMode):

	global soc_Client
	global soc_VMClient
	global map_StartingEnvToArticle
	global o_CacheInterface
	global file_InteractionLog
	global i_TotalArticles

	# load configurations & data			
	load_config (sys.argv)
	shutil.copyfile (sys.argv [1], get_config ('output_path') + '/run.cfg')
	random.seed ()

	i_TotalArticles = load_articles ()
	load_heldout_articles ()
	learner = Learner ()
	learner.init_learner ()
	if ('1' == get_config ('use_partial_annotation')):
		print '[INFO]  using partial annotations.'
		learner.load_partial_annotation ()

	bStartAfresh = ('restart' in sys.argv)
	if True == bStartAfresh:
		if 'Y' != raw_input ('   -- initialize weights and erase previous values?? [Y/n] : '):
			bStartAfresh = False
	if False == bStartAfresh:
		learner.load_weights ()
	else:
		learner.clear_weight_files ()

	# get configuration values ...			
	# sArticlePickleFile = get_config ('article_cache_file')
	sCacheFileName = get_config ('env_cache_file')
	sServerIP = get_config ('server_ip')
	iServerPort = int (get_config ('server_port'))
	iVMServerPort = int (get_config ('vm_server_port'))

	# perform prerun check of articles ...	
	bPrerunCheckOk = True
	for lstArticles in map_StartingEnvToArticle.values ():
		for oArticle in lstArticles:
			if False == learner.prerun_check_article (oArticle):
				bPrerunCheckOk = False
	if False == bPrerunCheckOk:
		return

	# connect to TCP relay ...				
	print '   connecting to server ' + sServerIP + ' : ' + str (iServerPort)
	soc_Client = socket.socket (socket.AF_INET, socket.SOCK_STREAM)
	soc_Client.connect ((sServerIP, iServerPort))
	clear_connection ()
	soc_VMClient = socket.socket (socket.AF_INET, socket.SOCK_STREAM)
	soc_VMClient.connect ((sServerIP, iVMServerPort))

	soc_Client.settimeout (120)

	# load or init cache ...				
	o_CacheInterface = CacheInterface ()
	if True == os.access (sCacheFileName, os.R_OK):
		print '   loading environment cache'
		fileCache = open (sCacheFileName)
		o_CacheInterface.load_cache (fileCache)
		fileCache.close ()


	file_InteractionLog = open (get_config ('interaction_logfile'), 'a')


	# learn !								
	print
	print '-------------------------------------------------'
	iLearningIterations = int (get_config ('learning_iterations'))
	iTestIterationPeriod = int (get_config ('test_iteration_period'))
	iMaxRepeatIterations = int (get_config ('max_repeat_iterations'))


	lstStartStates = map_StartingEnvToArticle.keys ()
	for i in xrange (iLearningIterations):

		learner.b_TestMode = False
		learner.d_ExplorationRate = float (get_config ('exploration_rate'))
		if ((0 != i) or (True == _bTestMode)) and (0 == (i % iTestIterationPeriod)):
			learner.b_TestMode = True
			learner.d_ExplorationRate = 1.0

			file_InteractionLog.write ('=================================================\n')
			file_InteractionLog.write ('[[ TEST MODE ]]\n')
			file_InteractionLog.write ('=================================================\n')
		else:
			file_InteractionLog.write ('=================================================\n')
			file_InteractionLog.write ('[[ EXPLORATION MODE ]]\n')
			file_InteractionLog.write ('=================================================\n')

		iArticleIndex = 0
		random.shuffle (lstStartStates)
		for sStartingEnv in lstStartStates:
			lstArticles = map_StartingEnvToArticle [sStartingEnv]
			random.shuffle (lstArticles)

			lstArticlesToBeReProcessed = []
			for oArticle in lstArticles:
				assert (sStartingEnv == oArticle.s_RequiredStartingEnvState)
				iArticleIndex = iArticleIndex + 1

				if False == learner.b_TestMode:
					if oArticle.i_ID in set_HeldoutArticles:
						continue

				learner.d_ExplorationRate = float (get_config ('exploration_rate'))
				
				# tic = time.clock ()
				sHeldoutMarker = ''
				if oArticle.i_ID in set_HeldoutArticles:
					sHeldoutMarker = 'heldout'

				print 
				print '   ' + str(i) + ':0' + ' article [' + oArticle.i_ID + '] ' +\
						str (iArticleIndex) + '/' + str (i_TotalArticles) + ', ' +\
						str (len (oArticle.lst_Instructions)) + ' instructions ' + sHeldoutMarker
				file_InteractionLog.write ('-------------------------------------------------\n')
				file_InteractionLog.write ('   ' + str(i) + ':0' + \
											' article [' + oArticle.i_ID + '] ' +\
											str (iArticleIndex) + '/' + \
											str (i_TotalArticles) + ', ' +\
											str (len (oArticle.lst_Instructions)) +\
											' instructions ' + sHeldoutMarker + '\n')

				learner.process_article (oArticle)
				# toc = time.clock ()
				# print '   ' + str (toc - tic) + ' seconds'


			# END [for n, oArticle in enumerate (lstArticles)]	


		# dump environment cache to file ...
		if (0 != i) and (0 == (i % 1)):
			try:
				if True == o_CacheInterface.b_NeedSave:
					fileCache = open (sCacheFileName + '.new', 'w')
					o_CacheInterface.save_cache (fileCache)
					fileCache.flush ()
					fileCache.close ()

					if True == os.access (sCacheFileName, os.R_OK):
						os.unlink (sCacheFileName)
					os.rename (sCacheFileName + '.new', sCacheFileName)

				o_CacheInterface.b_NeedSave = False
			except:
				print 'failed to dump environment cache to file.'
				print '   ' + str (sys.exc_info())
				file_InteractionLog.write ('[WARNING] failed to dump environment cache to file.\n')
				file_InteractionLog.write ('   ' + str (sys.exc_info()) + '\n')


		file_InteractionLog.flush ()
